// Code generated by pigeon; DO NOT EDIT.

package nosql

import (
	"bytes"
	"errors"
	"fmt"
	"io"
	"math"
	"os"
	"sort"
	"strconv"
	"strings"
	"sync"
	"unicode"
	"unicode/utf8"

	"github.com/pikami/cosmium/parsers"
)

func makeSelectStmt(columns, table, whereClause interface{}, count interface{}, orderList interface{}) (parsers.SelectStmt, error) {
	selectStmt := parsers.SelectStmt{
		SelectItems: columns.([]parsers.SelectItem),
		Table:       table.(parsers.Table),
	}

	if filters, ok := whereClause.(parsers.ComparisonExpression); ok {
		selectStmt.Filters = filters
	} else if filters, ok := whereClause.(parsers.LogicalExpression); ok {
		selectStmt.Filters = filters
	} else if filters, ok := whereClause.(parsers.Constant); ok {
		selectStmt.Filters = filters
	} else if filters, ok := whereClause.(parsers.SelectItem); ok {
		selectStmt.Filters = filters
	}

	if n, ok := count.(int); ok {
		selectStmt.Count = n
	}

	if orderExpressions, ok := orderList.([]parsers.OrderExpression); ok {
		selectStmt.OrderExpressions = orderExpressions
	}

	return selectStmt, nil
}

func makeSelectItem(name interface{}, path interface{}, selectItemType parsers.SelectItemType) (parsers.SelectItem, error) {
	ps := path.([]interface{})

	paths := make([]string, 1)
	paths[0] = name.(string)
	for _, p := range ps {
		paths = append(paths, p.(string))
	}

	return parsers.SelectItem{Path: paths, Type: selectItemType}, nil
}

func makeColumnList(column interface{}, other_columns interface{}) ([]parsers.SelectItem, error) {
	collsAsArray := other_columns.([]interface{})
	columnList := make([]parsers.SelectItem, len(collsAsArray)+1)
	columnList[0] = column.(parsers.SelectItem)

	for i, v := range collsAsArray {
		if col, ok := v.(parsers.SelectItem); ok {
			columnList[i+1] = col
		}
	}

	return columnList, nil
}

func makeSelectArray(columns interface{}) (parsers.SelectItem, error) {
	return parsers.SelectItem{
		SelectItems: columns.([]parsers.SelectItem),
		Type:        parsers.SelectItemTypeArray,
	}, nil
}

func makeSelectObject(field interface{}, other_fields interface{}) (parsers.SelectItem, error) {
	fieldsAsArray := other_fields.([]interface{})
	fieldsList := make([]parsers.SelectItem, len(fieldsAsArray)+1)
	fieldsList[0] = field.(parsers.SelectItem)

	for i, v := range fieldsAsArray {
		if col, ok := v.(parsers.SelectItem); ok {
			fieldsList[i+1] = col
		}
	}

	return parsers.SelectItem{
		SelectItems: fieldsList,
		Type:        parsers.SelectItemTypeObject,
	}, nil
}

func makeOrderByClause(ex1 interface{}, others interface{}) ([]parsers.OrderExpression, error) {
	othersArray := others.([]interface{})
	orderList := make([]parsers.OrderExpression, len(othersArray)+1)
	orderList[0] = ex1.(parsers.OrderExpression)

	for i, v := range othersArray {
		if col, ok := v.(parsers.OrderExpression); ok {
			orderList[i+1] = col
		}
	}

	return orderList, nil
}

func makeOrderExpression(field interface{}, order interface{}) (parsers.OrderExpression, error) {
	value := parsers.OrderExpression{
		SelectItem: field.(parsers.SelectItem),
		Direction:  parsers.OrderDirectionAsc,
	}

	if orderValue, ok := order.(parsers.OrderDirection); ok {
		value.Direction = orderValue
	}

	return value, nil
}

func createFunctionCall(functionType parsers.FunctionCallType, arguments []interface{}) (parsers.FunctionCall, error) {
	return parsers.FunctionCall{Type: functionType, Arguments: arguments}, nil
}

func joinStrings(array []interface{}) string {
	var stringsArray []string
	for _, elem := range array {
		str, ok := elem.(string)
		if !ok {
			continue
		}
		stringsArray = append(stringsArray, str)
	}

	return strings.Join(stringsArray, "")
}

func combineExpressions(ex1 interface{}, exs interface{}, operation parsers.LogicalExpressionType) (interface{}, error) {
	if exs == nil || len(exs.([]interface{})) < 1 {
		return ex1, nil
	}

	return parsers.LogicalExpression{
		Expressions: append([]interface{}{ex1}, exs.([]interface{})...),
		Operation:   operation,
	}, nil
}

var g = &grammar{
	rules: []*rule{
		{
			name: "Input",
			pos:  position{line: 140, col: 1, offset: 3971},
			expr: &actionExpr{
				pos: position{line: 140, col: 10, offset: 3980},
				run: (*parser).callonInput1,
				expr: &labeledExpr{
					pos:   position{line: 140, col: 10, offset: 3980},
					label: "selectStmt",
					expr: &ruleRefExpr{
						pos:  position{line: 140, col: 21, offset: 3991},
						name: "SelectStmt",
					},
				},
			},
		},
		{
			name: "SelectStmt",
			pos:  position{line: 144, col: 1, offset: 4034},
			expr: &actionExpr{
				pos: position{line: 144, col: 15, offset: 4048},
				run: (*parser).callonSelectStmt1,
				expr: &seqExpr{
					pos: position{line: 144, col: 15, offset: 4048},
					exprs: []any{
						&ruleRefExpr{
							pos:  position{line: 144, col: 15, offset: 4048},
							name: "Select",
						},
						&ruleRefExpr{
							pos:  position{line: 144, col: 22, offset: 4055},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 144, col: 25, offset: 4058},
							label: "topClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 144, col: 35, offset: 4068},
								expr: &ruleRefExpr{
									pos:  position{line: 144, col: 35, offset: 4068},
									name: "TopClause",
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 144, col: 46, offset: 4079},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 144, col: 49, offset: 4082},
							label: "columns",
							expr: &ruleRefExpr{
								pos:  position{line: 144, col: 57, offset: 4090},
								name: "Selection",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 144, col: 67, offset: 4100},
							name: "ws",
						},
						&ruleRefExpr{
							pos:  position{line: 145, col: 5, offset: 4107},
							name: "From",
						},
						&ruleRefExpr{
							pos:  position{line: 145, col: 10, offset: 4112},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 145, col: 13, offset: 4115},
							label: "table",
							expr: &ruleRefExpr{
								pos:  position{line: 145, col: 19, offset: 4121},
								name: "TableName",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 145, col: 29, offset: 4131},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 146, col: 5, offset: 4138},
							label: "whereClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 146, col: 17, offset: 4150},
								expr: &actionExpr{
									pos: position{line: 146, col: 18, offset: 4151},
									run: (*parser).callonSelectStmt19,
									expr: &seqExpr{
										pos: position{line: 146, col: 18, offset: 4151},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 146, col: 18, offset: 4151},
												name: "ws",
											},
											&ruleRefExpr{
												pos:  position{line: 146, col: 21, offset: 4154},
												name: "Where",
											},
											&ruleRefExpr{
												pos:  position{line: 146, col: 27, offset: 4160},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 146, col: 30, offset: 4163},
												label: "condition",
												expr: &ruleRefExpr{
													pos:  position{line: 146, col: 40, offset: 4173},
													name: "Condition",
												},
											},
										},
									},
								},
							},
						},
						&labeledExpr{
							pos:   position{line: 147, col: 5, offset: 4215},
							label: "orderByClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 147, col: 19, offset: 4229},
								expr: &ruleRefExpr{
									pos:  position{line: 147, col: 19, offset: 4229},
									name: "OrderByClause",
								},
							},
						},
					},
				},
			},
		},
		{
			name: "TopClause",
			pos:  position{line: 151, col: 1, offset: 4330},
			expr: &actionExpr{
				pos: position{line: 151, col: 14, offset: 4343},
				run: (*parser).callonTopClause1,
				expr: &seqExpr{
					pos: position{line: 151, col: 14, offset: 4343},
					exprs: []any{
						&ruleRefExpr{
							pos:  position{line: 151, col: 14, offset: 4343},
							name: "Top",
						},
						&ruleRefExpr{
							pos:  position{line: 151, col: 18, offset: 4347},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 151, col: 21, offset: 4350},
							label: "count",
							expr: &ruleRefExpr{
								pos:  position{line: 151, col: 27, offset: 4356},
								name: "Integer",
							},
						},
					},
				},
			},
		},
		{
			name: "Selection",
			pos:  position{line: 155, col: 1, offset: 4391},
			expr: &choiceExpr{
				pos: position{line: 155, col: 14, offset: 4404},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 155, col: 14, offset: 4404},
						name: "SelectValueSpec",
					},
					&ruleRefExpr{
						pos:  position{line: 155, col: 32, offset: 4422},
						name: "ColumnList",
					},
					&ruleRefExpr{
						pos:  position{line: 155, col: 45, offset: 4435},
						name: "SelectAsterisk",
					},
				},
			},
		},
		{
			name: "SelectAsterisk",
			pos:  position{line: 157, col: 1, offset: 4451},
			expr: &actionExpr{
				pos: position{line: 157, col: 19, offset: 4469},
				run: (*parser).callonSelectAsterisk1,
				expr: &litMatcher{
					pos:        position{line: 157, col: 19, offset: 4469},
					val:        "*",
					ignoreCase: false,
					want:       "\"*\"",
				},
			},
		},
		{
			name: "ColumnList",
			pos:  position{line: 163, col: 1, offset: 4664},
			expr: &actionExpr{
				pos: position{line: 163, col: 15, offset: 4678},
				run: (*parser).callonColumnList1,
				expr: &seqExpr{
					pos: position{line: 163, col: 15, offset: 4678},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 163, col: 15, offset: 4678},
							label: "column",
							expr: &ruleRefExpr{
								pos:  position{line: 163, col: 22, offset: 4685},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 163, col: 33, offset: 4696},
							label: "other_columns",
							expr: &zeroOrMoreExpr{
								pos: position{line: 163, col: 47, offset: 4710},
								expr: &actionExpr{
									pos: position{line: 163, col: 48, offset: 4711},
									run: (*parser).callonColumnList7,
									expr: &seqExpr{
										pos: position{line: 163, col: 48, offset: 4711},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 163, col: 48, offset: 4711},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 163, col: 51, offset: 4714},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 163, col: 55, offset: 4718},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 163, col: 58, offset: 4721},
												label: "coll",
												expr: &ruleRefExpr{
													pos:  position{line: 163, col: 63, offset: 4726},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "SelectValueSpec",
			pos:  position{line: 167, col: 1, offset: 4813},
			expr: &actionExpr{
				pos: position{line: 167, col: 20, offset: 4832},
				run: (*parser).callonSelectValueSpec1,
				expr: &seqExpr{
					pos: position{line: 167, col: 20, offset: 4832},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 167, col: 20, offset: 4832},
							val:        "value",
							ignoreCase: true,
							want:       "\"VALUE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 167, col: 29, offset: 4841},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 167, col: 32, offset: 4844},
							label: "column",
							expr: &ruleRefExpr{
								pos:  position{line: 167, col: 39, offset: 4851},
								name: "SelectItem",
							},
						},
					},
				},
			},
		},
		{
			name: "TableName",
			pos:  position{line: 173, col: 1, offset: 5005},
			expr: &actionExpr{
				pos: position{line: 173, col: 14, offset: 5018},
				run: (*parser).callonTableName1,
				expr: &labeledExpr{
					pos:   position{line: 173, col: 14, offset: 5018},
					label: "key",
					expr: &ruleRefExpr{
						pos:  position{line: 173, col: 18, offset: 5022},
						name: "Identifier",
					},
				},
			},
		},
		{
			name: "SelectArray",
			pos:  position{line: 177, col: 1, offset: 5089},
			expr: &actionExpr{
				pos: position{line: 177, col: 16, offset: 5104},
				run: (*parser).callonSelectArray1,
				expr: &seqExpr{
					pos: position{line: 177, col: 16, offset: 5104},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 177, col: 16, offset: 5104},
							val:        "[",
							ignoreCase: false,
							want:       "\"[\"",
						},
						&ruleRefExpr{
							pos:  position{line: 177, col: 20, offset: 5108},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 177, col: 23, offset: 5111},
							label: "columns",
							expr: &ruleRefExpr{
								pos:  position{line: 177, col: 31, offset: 5119},
								name: "ColumnList",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 177, col: 42, offset: 5130},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 177, col: 45, offset: 5133},
							val:        "]",
							ignoreCase: false,
							want:       "\"]\"",
						},
					},
				},
			},
		},
		{
			name: "SelectObject",
			pos:  position{line: 181, col: 1, offset: 5178},
			expr: &actionExpr{
				pos: position{line: 181, col: 17, offset: 5194},
				run: (*parser).callonSelectObject1,
				expr: &seqExpr{
					pos: position{line: 181, col: 17, offset: 5194},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 181, col: 17, offset: 5194},
							val:        "{",
							ignoreCase: false,
							want:       "\"{\"",
						},
						&ruleRefExpr{
							pos:  position{line: 181, col: 21, offset: 5198},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 181, col: 24, offset: 5201},
							label: "field",
							expr: &ruleRefExpr{
								pos:  position{line: 181, col: 30, offset: 5207},
								name: "SelectObjectField",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 181, col: 48, offset: 5225},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 181, col: 51, offset: 5228},
							label: "other_fields",
							expr: &zeroOrMoreExpr{
								pos: position{line: 181, col: 64, offset: 5241},
								expr: &actionExpr{
									pos: position{line: 181, col: 65, offset: 5242},
									run: (*parser).callonSelectObject10,
									expr: &seqExpr{
										pos: position{line: 181, col: 65, offset: 5242},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 181, col: 65, offset: 5242},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 181, col: 68, offset: 5245},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 181, col: 72, offset: 5249},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 181, col: 75, offset: 5252},
												label: "coll",
												expr: &ruleRefExpr{
													pos:  position{line: 181, col: 80, offset: 5257},
													name: "SelectObjectField",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 181, col: 120, offset: 5297},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 181, col: 123, offset: 5300},
							val:        "}",
							ignoreCase: false,
							want:       "\"}\"",
						},
					},
				},
			},
		},
		{
			name: "SelectObjectField",
			pos:  position{line: 185, col: 1, offset: 5358},
			expr: &actionExpr{
				pos: position{line: 185, col: 22, offset: 5379},
				run: (*parser).callonSelectObjectField1,
				expr: &seqExpr{
					pos: position{line: 185, col: 22, offset: 5379},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 185, col: 22, offset: 5379},
							label: "name",
							expr: &choiceExpr{
								pos: position{line: 185, col: 28, offset: 5385},
								alternatives: []any{
									&ruleRefExpr{
										pos:  position{line: 185, col: 28, offset: 5385},
										name: "Identifier",
									},
									&actionExpr{
										pos: position{line: 185, col: 41, offset: 5398},
										run: (*parser).callonSelectObjectField6,
										expr: &seqExpr{
											pos: position{line: 185, col: 41, offset: 5398},
											exprs: []any{
												&litMatcher{
													pos:        position{line: 185, col: 41, offset: 5398},
													val:        "\"",
													ignoreCase: false,
													want:       "\"\\\"\"",
												},
												&labeledExpr{
													pos:   position{line: 185, col: 46, offset: 5403},
													label: "key",
													expr: &ruleRefExpr{
														pos:  position{line: 185, col: 50, offset: 5407},
														name: "Identifier",
													},
												},
												&litMatcher{
													pos:        position{line: 185, col: 61, offset: 5418},
													val:        "\"",
													ignoreCase: false,
													want:       "\"\\\"\"",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 185, col: 87, offset: 5444},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 185, col: 90, offset: 5447},
							val:        ":",
							ignoreCase: false,
							want:       "\":\"",
						},
						&ruleRefExpr{
							pos:  position{line: 185, col: 94, offset: 5451},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 185, col: 97, offset: 5454},
							label: "selectItem",
							expr: &ruleRefExpr{
								pos:  position{line: 185, col: 108, offset: 5465},
								name: "SelectItem",
							},
						},
					},
				},
			},
		},
		{
			name: "SelectProperty",
			pos:  position{line: 191, col: 1, offset: 5571},
			expr: &actionExpr{
				pos: position{line: 191, col: 19, offset: 5589},
				run: (*parser).callonSelectProperty1,
				expr: &seqExpr{
					pos: position{line: 191, col: 19, offset: 5589},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 191, col: 19, offset: 5589},
							label: "name",
							expr: &ruleRefExpr{
								pos:  position{line: 191, col: 24, offset: 5594},
								name: "Identifier",
							},
						},
						&labeledExpr{
							pos:   position{line: 191, col: 35, offset: 5605},
							label: "path",
							expr: &zeroOrMoreExpr{
								pos: position{line: 191, col: 40, offset: 5610},
								expr: &choiceExpr{
									pos: position{line: 191, col: 41, offset: 5611},
									alternatives: []any{
										&ruleRefExpr{
											pos:  position{line: 191, col: 41, offset: 5611},
											name: "DotFieldAccess",
										},
										&ruleRefExpr{
											pos:  position{line: 191, col: 58, offset: 5628},
											name: "ArrayFieldAccess",
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "SelectItem",
			pos:  position{line: 195, col: 1, offset: 5719},
			expr: &actionExpr{
				pos: position{line: 195, col: 15, offset: 5733},
				run: (*parser).callonSelectItem1,
				expr: &seqExpr{
					pos: position{line: 195, col: 15, offset: 5733},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 195, col: 15, offset: 5733},
							label: "selectItem",
							expr: &choiceExpr{
								pos: position{line: 195, col: 27, offset: 5745},
								alternatives: []any{
									&ruleRefExpr{
										pos:  position{line: 195, col: 27, offset: 5745},
										name: "Literal",
									},
									&ruleRefExpr{
										pos:  position{line: 195, col: 37, offset: 5755},
										name: "FunctionCall",
									},
									&ruleRefExpr{
										pos:  position{line: 195, col: 52, offset: 5770},
										name: "SelectArray",
									},
									&ruleRefExpr{
										pos:  position{line: 195, col: 66, offset: 5784},
										name: "SelectObject",
									},
									&ruleRefExpr{
										pos:  position{line: 195, col: 81, offset: 5799},
										name: "SelectProperty",
									},
								},
							},
						},
						&labeledExpr{
							pos:   position{line: 195, col: 97, offset: 5815},
							label: "asClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 195, col: 106, offset: 5824},
								expr: &ruleRefExpr{
									pos:  position{line: 195, col: 106, offset: 5824},
									name: "AsClause",
								},
							},
						},
					},
				},
			},
		},
		{
			name: "AsClause",
			pos:  position{line: 219, col: 1, offset: 6422},
			expr: &actionExpr{
				pos: position{line: 219, col: 13, offset: 6434},
				run: (*parser).callonAsClause1,
				expr: &seqExpr{
					pos: position{line: 219, col: 13, offset: 6434},
					exprs: []any{
						&ruleRefExpr{
							pos:  position{line: 219, col: 13, offset: 6434},
							name: "ws",
						},
						&ruleRefExpr{
							pos:  position{line: 219, col: 16, offset: 6437},
							name: "As",
						},
						&ruleRefExpr{
							pos:  position{line: 219, col: 19, offset: 6440},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 219, col: 22, offset: 6443},
							label: "alias",
							expr: &ruleRefExpr{
								pos:  position{line: 219, col: 28, offset: 6449},
								name: "Identifier",
							},
						},
					},
				},
			},
		},
		{
			name: "DotFieldAccess",
			pos:  position{line: 221, col: 1, offset: 6483},
			expr: &actionExpr{
				pos: position{line: 221, col: 19, offset: 6501},
				run: (*parser).callonDotFieldAccess1,
				expr: &seqExpr{
					pos: position{line: 221, col: 19, offset: 6501},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 221, col: 19, offset: 6501},
							val:        ".",
							ignoreCase: false,
							want:       "\".\"",
						},
						&labeledExpr{
							pos:   position{line: 221, col: 23, offset: 6505},
							label: "id",
							expr: &ruleRefExpr{
								pos:  position{line: 221, col: 26, offset: 6508},
								name: "Identifier",
							},
						},
					},
				},
			},
		},
		{
			name: "ArrayFieldAccess",
			pos:  position{line: 225, col: 1, offset: 6543},
			expr: &actionExpr{
				pos: position{line: 225, col: 21, offset: 6563},
				run: (*parser).callonArrayFieldAccess1,
				expr: &seqExpr{
					pos: position{line: 225, col: 21, offset: 6563},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 225, col: 21, offset: 6563},
							val:        "[\"",
							ignoreCase: false,
							want:       "\"[\\\"\"",
						},
						&labeledExpr{
							pos:   position{line: 225, col: 27, offset: 6569},
							label: "id",
							expr: &ruleRefExpr{
								pos:  position{line: 225, col: 30, offset: 6572},
								name: "Identifier",
							},
						},
						&litMatcher{
							pos:        position{line: 225, col: 41, offset: 6583},
							val:        "\"]",
							ignoreCase: false,
							want:       "\"\\\"]\"",
						},
					},
				},
			},
		},
		{
			name: "Identifier",
			pos:  position{line: 229, col: 1, offset: 6613},
			expr: &actionExpr{
				pos: position{line: 229, col: 15, offset: 6627},
				run: (*parser).callonIdentifier1,
				expr: &seqExpr{
					pos: position{line: 229, col: 15, offset: 6627},
					exprs: []any{
						&charClassMatcher{
							pos:        position{line: 229, col: 15, offset: 6627},
							val:        "[a-zA-Z_]",
							chars:      []rune{'_'},
							ranges:     []rune{'a', 'z', 'A', 'Z'},
							ignoreCase: false,
							inverted:   false,
						},
						&zeroOrMoreExpr{
							pos: position{line: 229, col: 24, offset: 6636},
							expr: &charClassMatcher{
								pos:        position{line: 229, col: 24, offset: 6636},
								val:        "[a-zA-Z0-9_]",
								chars:      []rune{'_'},
								ranges:     []rune{'a', 'z', 'A', 'Z', '0', '9'},
								ignoreCase: false,
								inverted:   false,
							},
						},
					},
				},
			},
		},
		{
			name: "Condition",
			pos:  position{line: 233, col: 1, offset: 6686},
			expr: &actionExpr{
				pos: position{line: 233, col: 14, offset: 6699},
				run: (*parser).callonCondition1,
				expr: &labeledExpr{
					pos:   position{line: 233, col: 14, offset: 6699},
					label: "expression",
					expr: &ruleRefExpr{
						pos:  position{line: 233, col: 25, offset: 6710},
						name: "OrExpression",
					},
				},
			},
		},
		{
			name: "OrExpression",
			pos:  position{line: 237, col: 1, offset: 6755},
			expr: &actionExpr{
				pos: position{line: 237, col: 17, offset: 6771},
				run: (*parser).callonOrExpression1,
				expr: &seqExpr{
					pos: position{line: 237, col: 17, offset: 6771},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 237, col: 17, offset: 6771},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 237, col: 21, offset: 6775},
								name: "AndExpression",
							},
						},
						&labeledExpr{
							pos:   position{line: 237, col: 35, offset: 6789},
							label: "ex2",
							expr: &zeroOrMoreExpr{
								pos: position{line: 237, col: 39, offset: 6793},
								expr: &actionExpr{
									pos: position{line: 237, col: 40, offset: 6794},
									run: (*parser).callonOrExpression7,
									expr: &seqExpr{
										pos: position{line: 237, col: 40, offset: 6794},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 237, col: 40, offset: 6794},
												name: "ws",
											},
											&ruleRefExpr{
												pos:  position{line: 237, col: 43, offset: 6797},
												name: "Or",
											},
											&ruleRefExpr{
												pos:  position{line: 237, col: 46, offset: 6800},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 237, col: 49, offset: 6803},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 237, col: 52, offset: 6806},
													name: "AndExpression",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "AndExpression",
			pos:  position{line: 241, col: 1, offset: 6919},
			expr: &actionExpr{
				pos: position{line: 241, col: 18, offset: 6936},
				run: (*parser).callonAndExpression1,
				expr: &seqExpr{
					pos: position{line: 241, col: 18, offset: 6936},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 241, col: 18, offset: 6936},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 241, col: 22, offset: 6940},
								name: "ComparisonExpression",
							},
						},
						&labeledExpr{
							pos:   position{line: 241, col: 43, offset: 6961},
							label: "ex2",
							expr: &zeroOrMoreExpr{
								pos: position{line: 241, col: 47, offset: 6965},
								expr: &actionExpr{
									pos: position{line: 241, col: 48, offset: 6966},
									run: (*parser).callonAndExpression7,
									expr: &seqExpr{
										pos: position{line: 241, col: 48, offset: 6966},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 241, col: 48, offset: 6966},
												name: "ws",
											},
											&ruleRefExpr{
												pos:  position{line: 241, col: 51, offset: 6969},
												name: "And",
											},
											&ruleRefExpr{
												pos:  position{line: 241, col: 55, offset: 6973},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 241, col: 58, offset: 6976},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 241, col: 61, offset: 6979},
													name: "ComparisonExpression",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "ComparisonExpression",
			pos:  position{line: 245, col: 1, offset: 7100},
			expr: &choiceExpr{
				pos: position{line: 245, col: 25, offset: 7124},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 245, col: 25, offset: 7124},
						run: (*parser).callonComparisonExpression2,
						expr: &seqExpr{
							pos: position{line: 245, col: 25, offset: 7124},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 245, col: 25, offset: 7124},
									val:        "(",
									ignoreCase: false,
									want:       "\"(\"",
								},
								&ruleRefExpr{
									pos:  position{line: 245, col: 29, offset: 7128},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 245, col: 32, offset: 7131},
									label: "ex",
									expr: &ruleRefExpr{
										pos:  position{line: 245, col: 35, offset: 7134},
										name: "OrExpression",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 245, col: 48, offset: 7147},
									name: "ws",
								},
								&litMatcher{
									pos:        position{line: 245, col: 51, offset: 7150},
									val:        ")",
									ignoreCase: false,
									want:       "\")\"",
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 246, col: 7, offset: 7179},
						run: (*parser).callonComparisonExpression10,
						expr: &seqExpr{
							pos: position{line: 246, col: 7, offset: 7179},
							exprs: []any{
								&labeledExpr{
									pos:   position{line: 246, col: 7, offset: 7179},
									label: "left",
									expr: &ruleRefExpr{
										pos:  position{line: 246, col: 12, offset: 7184},
										name: "SelectItem",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 246, col: 23, offset: 7195},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 246, col: 26, offset: 7198},
									label: "op",
									expr: &ruleRefExpr{
										pos:  position{line: 246, col: 29, offset: 7201},
										name: "ComparisonOperator",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 246, col: 48, offset: 7220},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 246, col: 51, offset: 7223},
									label: "right",
									expr: &ruleRefExpr{
										pos:  position{line: 246, col: 57, offset: 7229},
										name: "SelectItem",
									},
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 248, col: 5, offset: 7336},
						run: (*parser).callonComparisonExpression20,
						expr: &labeledExpr{
							pos:   position{line: 248, col: 5, offset: 7336},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 248, col: 8, offset: 7339},
								name: "BooleanLiteral",
							},
						},
					},
					&actionExpr{
						pos: position{line: 249, col: 5, offset: 7377},
						run: (*parser).callonComparisonExpression23,
						expr: &labeledExpr{
							pos:   position{line: 249, col: 5, offset: 7377},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 249, col: 8, offset: 7380},
								name: "SelectItem",
							},
						},
					},
				},
			},
		},
		{
			name: "OrderByClause",
			pos:  position{line: 251, col: 1, offset: 7411},
			expr: &actionExpr{
				pos: position{line: 251, col: 18, offset: 7428},
				run: (*parser).callonOrderByClause1,
				expr: &seqExpr{
					pos: position{line: 251, col: 18, offset: 7428},
					exprs: []any{
						&ruleRefExpr{
							pos:  position{line: 251, col: 18, offset: 7428},
							name: "OrderBy",
						},
						&ruleRefExpr{
							pos:  position{line: 251, col: 26, offset: 7436},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 251, col: 29, offset: 7439},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 251, col: 33, offset: 7443},
								name: "OrderExpression",
							},
						},
						&labeledExpr{
							pos:   position{line: 251, col: 49, offset: 7459},
							label: "others",
							expr: &zeroOrMoreExpr{
								pos: position{line: 251, col: 56, offset: 7466},
								expr: &actionExpr{
									pos: position{line: 251, col: 57, offset: 7467},
									run: (*parser).callonOrderByClause9,
									expr: &seqExpr{
										pos: position{line: 251, col: 57, offset: 7467},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 251, col: 57, offset: 7467},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 251, col: 60, offset: 7470},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 251, col: 64, offset: 7474},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 251, col: 67, offset: 7477},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 251, col: 70, offset: 7480},
													name: "OrderExpression",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "OrderExpression",
			pos:  position{line: 255, col: 1, offset: 7564},
			expr: &actionExpr{
				pos: position{line: 255, col: 20, offset: 7583},
				run: (*parser).callonOrderExpression1,
				expr: &seqExpr{
					pos: position{line: 255, col: 20, offset: 7583},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 255, col: 20, offset: 7583},
							label: "field",
							expr: &ruleRefExpr{
								pos:  position{line: 255, col: 26, offset: 7589},
								name: "SelectProperty",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 255, col: 41, offset: 7604},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 255, col: 44, offset: 7607},
							label: "order",
							expr: &zeroOrOneExpr{
								pos: position{line: 255, col: 50, offset: 7613},
								expr: &ruleRefExpr{
									pos:  position{line: 255, col: 50, offset: 7613},
									name: "OrderDirection",
								},
							},
						},
					},
				},
			},
		},
		{
			name: "OrderDirection",
			pos:  position{line: 259, col: 1, offset: 7679},
			expr: &actionExpr{
				pos: position{line: 259, col: 19, offset: 7697},
				run: (*parser).callonOrderDirection1,
				expr: &choiceExpr{
					pos: position{line: 259, col: 20, offset: 7698},
					alternatives: []any{
						&litMatcher{
							pos:        position{line: 259, col: 20, offset: 7698},
							val:        "asc",
							ignoreCase: true,
							want:       "\"ASC\"i",
						},
						&litMatcher{
							pos:        position{line: 259, col: 29, offset: 7707},
							val:        "desc",
							ignoreCase: true,
							want:       "\"DESC\"i",
						},
					},
				},
			},
		},
		{
			name: "Select",
			pos:  position{line: 267, col: 1, offset: 7859},
			expr: &litMatcher{
				pos:        position{line: 267, col: 11, offset: 7869},
				val:        "select",
				ignoreCase: true,
				want:       "\"SELECT\"i",
			},
		},
		{
			name: "Top",
			pos:  position{line: 269, col: 1, offset: 7880},
			expr: &litMatcher{
				pos:        position{line: 269, col: 8, offset: 7887},
				val:        "top",
				ignoreCase: true,
				want:       "\"TOP\"i",
			},
		},
		{
			name: "As",
			pos:  position{line: 271, col: 1, offset: 7895},
			expr: &litMatcher{
				pos:        position{line: 271, col: 7, offset: 7901},
				val:        "as",
				ignoreCase: true,
				want:       "\"AS\"i",
			},
		},
		{
			name: "From",
			pos:  position{line: 273, col: 1, offset: 7908},
			expr: &litMatcher{
				pos:        position{line: 273, col: 9, offset: 7916},
				val:        "from",
				ignoreCase: true,
				want:       "\"FROM\"i",
			},
		},
		{
			name: "Where",
			pos:  position{line: 275, col: 1, offset: 7925},
			expr: &litMatcher{
				pos:        position{line: 275, col: 10, offset: 7934},
				val:        "where",
				ignoreCase: true,
				want:       "\"WHERE\"i",
			},
		},
		{
			name: "And",
			pos:  position{line: 277, col: 1, offset: 7944},
			expr: &litMatcher{
				pos:        position{line: 277, col: 8, offset: 7951},
				val:        "and",
				ignoreCase: true,
				want:       "\"AND\"i",
			},
		},
		{
			name: "Or",
			pos:  position{line: 279, col: 1, offset: 7959},
			expr: &litMatcher{
				pos:        position{line: 279, col: 7, offset: 7965},
				val:        "or",
				ignoreCase: true,
				want:       "\"OR\"i",
			},
		},
		{
			name: "OrderBy",
			pos:  position{line: 281, col: 1, offset: 7972},
			expr: &seqExpr{
				pos: position{line: 281, col: 12, offset: 7983},
				exprs: []any{
					&litMatcher{
						pos:        position{line: 281, col: 12, offset: 7983},
						val:        "order",
						ignoreCase: true,
						want:       "\"ORDER\"i",
					},
					&ruleRefExpr{
						pos:  position{line: 281, col: 21, offset: 7992},
						name: "ws",
					},
					&litMatcher{
						pos:        position{line: 281, col: 24, offset: 7995},
						val:        "by",
						ignoreCase: true,
						want:       "\"BY\"i",
					},
				},
			},
		},
		{
			name: "ComparisonOperator",
			pos:  position{line: 283, col: 1, offset: 8002},
			expr: &actionExpr{
				pos: position{line: 283, col: 23, offset: 8024},
				run: (*parser).callonComparisonOperator1,
				expr: &choiceExpr{
					pos: position{line: 283, col: 24, offset: 8025},
					alternatives: []any{
						&litMatcher{
							pos:        position{line: 283, col: 24, offset: 8025},
							val:        "=",
							ignoreCase: false,
							want:       "\"=\"",
						},
						&litMatcher{
							pos:        position{line: 283, col: 30, offset: 8031},
							val:        "!=",
							ignoreCase: false,
							want:       "\"!=\"",
						},
						&litMatcher{
							pos:        position{line: 283, col: 37, offset: 8038},
							val:        "<",
							ignoreCase: false,
							want:       "\"<\"",
						},
						&litMatcher{
							pos:        position{line: 283, col: 43, offset: 8044},
							val:        "<=",
							ignoreCase: false,
							want:       "\"<=\"",
						},
						&litMatcher{
							pos:        position{line: 283, col: 50, offset: 8051},
							val:        ">",
							ignoreCase: false,
							want:       "\">\"",
						},
						&litMatcher{
							pos:        position{line: 283, col: 56, offset: 8057},
							val:        ">=",
							ignoreCase: false,
							want:       "\">=\"",
						},
					},
				},
			},
		},
		{
			name: "StringEquals",
			pos:  position{line: 287, col: 1, offset: 8099},
			expr: &litMatcher{
				pos:        position{line: 287, col: 17, offset: 8115},
				val:        "stringequals",
				ignoreCase: true,
				want:       "\"STRINGEQUALS\"i",
			},
		},
		{
			name: "Literal",
			pos:  position{line: 289, col: 1, offset: 8132},
			expr: &choiceExpr{
				pos: position{line: 289, col: 12, offset: 8143},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 289, col: 12, offset: 8143},
						name: "FloatLiteral",
					},
					&ruleRefExpr{
						pos:  position{line: 289, col: 27, offset: 8158},
						name: "IntegerLiteral",
					},
					&ruleRefExpr{
						pos:  position{line: 289, col: 44, offset: 8175},
						name: "StringLiteral",
					},
					&ruleRefExpr{
						pos:  position{line: 289, col: 60, offset: 8191},
						name: "BooleanLiteral",
					},
					&ruleRefExpr{
						pos:  position{line: 289, col: 77, offset: 8208},
						name: "ParameterConstant",
					},
					&ruleRefExpr{
						pos:  position{line: 289, col: 97, offset: 8228},
						name: "NullConstant",
					},
				},
			},
		},
		{
			name: "ParameterConstant",
			pos:  position{line: 291, col: 1, offset: 8242},
			expr: &actionExpr{
				pos: position{line: 291, col: 22, offset: 8263},
				run: (*parser).callonParameterConstant1,
				expr: &seqExpr{
					pos: position{line: 291, col: 22, offset: 8263},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 291, col: 22, offset: 8263},
							val:        "@",
							ignoreCase: false,
							want:       "\"@\"",
						},
						&ruleRefExpr{
							pos:  position{line: 291, col: 26, offset: 8267},
							name: "Identifier",
						},
					},
				},
			},
		},
		{
			name: "NullConstant",
			pos:  position{line: 294, col: 1, offset: 8383},
			expr: &actionExpr{
				pos: position{line: 294, col: 17, offset: 8399},
				run: (*parser).callonNullConstant1,
				expr: &litMatcher{
					pos:        position{line: 294, col: 17, offset: 8399},
					val:        "null",
					ignoreCase: false,
					want:       "\"null\"",
				},
			},
		},
		{
			name: "IntegerLiteral",
			pos:  position{line: 298, col: 1, offset: 8456},
			expr: &actionExpr{
				pos: position{line: 298, col: 19, offset: 8474},
				run: (*parser).callonIntegerLiteral1,
				expr: &labeledExpr{
					pos:   position{line: 298, col: 19, offset: 8474},
					label: "number",
					expr: &ruleRefExpr{
						pos:  position{line: 298, col: 26, offset: 8481},
						name: "Integer",
					},
				},
			},
		},
		{
			name: "StringLiteral",
			pos:  position{line: 301, col: 1, offset: 8582},
			expr: &actionExpr{
				pos: position{line: 301, col: 18, offset: 8599},
				run: (*parser).callonStringLiteral1,
				expr: &seqExpr{
					pos: position{line: 301, col: 18, offset: 8599},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 301, col: 18, offset: 8599},
							val:        "\"",
							ignoreCase: false,
							want:       "\"\\\"\"",
						},
						&labeledExpr{
							pos:   position{line: 301, col: 23, offset: 8604},
							label: "chars",
							expr: &zeroOrMoreExpr{
								pos: position{line: 301, col: 29, offset: 8610},
								expr: &ruleRefExpr{
									pos:  position{line: 301, col: 29, offset: 8610},
									name: "StringCharacter",
								},
							},
						},
						&litMatcher{
							pos:        position{line: 301, col: 46, offset: 8627},
							val:        "\"",
							ignoreCase: false,
							want:       "\"\\\"\"",
						},
					},
				},
			},
		},
		{
			name: "FloatLiteral",
			pos:  position{line: 304, col: 1, offset: 8745},
			expr: &actionExpr{
				pos: position{line: 304, col: 17, offset: 8761},
				run: (*parser).callonFloatLiteral1,
				expr: &seqExpr{
					pos: position{line: 304, col: 17, offset: 8761},
					exprs: []any{
						&oneOrMoreExpr{
							pos: position{line: 304, col: 17, offset: 8761},
							expr: &charClassMatcher{
								pos:        position{line: 304, col: 17, offset: 8761},
								val:        "[0-9]",
								ranges:     []rune{'0', '9'},
								ignoreCase: false,
								inverted:   false,
							},
						},
						&litMatcher{
							pos:        position{line: 304, col: 23, offset: 8767},
							val:        ".",
							ignoreCase: false,
							want:       "\".\"",
						},
						&oneOrMoreExpr{
							pos: position{line: 304, col: 26, offset: 8770},
							expr: &charClassMatcher{
								pos:        position{line: 304, col: 26, offset: 8770},
								val:        "[0-9]",
								ranges:     []rune{'0', '9'},
								ignoreCase: false,
								inverted:   false,
							},
						},
					},
				},
			},
		},
		{
			name: "BooleanLiteral",
			pos:  position{line: 308, col: 1, offset: 8926},
			expr: &actionExpr{
				pos: position{line: 308, col: 19, offset: 8944},
				run: (*parser).callonBooleanLiteral1,
				expr: &choiceExpr{
					pos: position{line: 308, col: 20, offset: 8945},
					alternatives: []any{
						&litMatcher{
							pos:        position{line: 308, col: 20, offset: 8945},
							val:        "true",
							ignoreCase: true,
							want:       "\"true\"i",
						},
						&litMatcher{
							pos:        position{line: 308, col: 30, offset: 8955},
							val:        "false",
							ignoreCase: true,
							want:       "\"false\"i",
						},
					},
				},
			},
		},
		{
			name: "FunctionCall",
			pos:  position{line: 313, col: 1, offset: 9110},
			expr: &choiceExpr{
				pos: position{line: 313, col: 17, offset: 9126},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 313, col: 17, offset: 9126},
						name: "StringFunctions",
					},
					&ruleRefExpr{
						pos:  position{line: 314, col: 7, offset: 9148},
						name: "TypeCheckingFunctions",
					},
					&ruleRefExpr{
						pos:  position{line: 315, col: 7, offset: 9176},
						name: "ArrayFunctions",
					},
					&ruleRefExpr{
						pos:  position{line: 316, col: 7, offset: 9197},
						name: "InFunction",
					},
				},
			},
		},
		{
			name: "StringFunctions",
			pos:  position{line: 318, col: 1, offset: 9209},
			expr: &choiceExpr{
				pos: position{line: 318, col: 20, offset: 9228},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 318, col: 20, offset: 9228},
						name: "StringEqualsExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 319, col: 7, offset: 9257},
						name: "ToStringExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 320, col: 7, offset: 9282},
						name: "ConcatExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 321, col: 7, offset: 9305},
						name: "ThreeArgumentStringFunctionExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 322, col: 7, offset: 9349},
						name: "UpperExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 323, col: 7, offset: 9371},
						name: "LowerExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 324, col: 7, offset: 9393},
						name: "LeftExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 325, col: 7, offset: 9414},
						name: "LengthExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 326, col: 7, offset: 9437},
						name: "LTrimExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 327, col: 7, offset: 9459},
						name: "ReplaceExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 328, col: 7, offset: 9483},
						name: "ReplicateExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 329, col: 7, offset: 9509},
						name: "ReverseExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 330, col: 7, offset: 9533},
						name: "RightExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 331, col: 7, offset: 9555},
						name: "RTrimExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 332, col: 7, offset: 9577},
						name: "SubstringExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 333, col: 7, offset: 9603},
						name: "TrimExpression",
					},
				},
			},
		},
		{
			name: "TypeCheckingFunctions",
			pos:  position{line: 335, col: 1, offset: 9619},
			expr: &choiceExpr{
				pos: position{line: 335, col: 26, offset: 9644},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 335, col: 26, offset: 9644},
						name: "IsDefined",
					},
					&ruleRefExpr{
						pos:  position{line: 336, col: 7, offset: 9660},
						name: "IsArray",
					},
					&ruleRefExpr{
						pos:  position{line: 337, col: 7, offset: 9674},
						name: "IsBool",
					},
					&ruleRefExpr{
						pos:  position{line: 338, col: 7, offset: 9687},
						name: "IsFiniteNumber",
					},
					&ruleRefExpr{
						pos:  position{line: 339, col: 7, offset: 9708},
						name: "IsInteger",
					},
					&ruleRefExpr{
						pos:  position{line: 340, col: 7, offset: 9724},
						name: "IsNull",
					},
					&ruleRefExpr{
						pos:  position{line: 341, col: 7, offset: 9737},
						name: "IsNumber",
					},
					&ruleRefExpr{
						pos:  position{line: 342, col: 7, offset: 9752},
						name: "IsObject",
					},
					&ruleRefExpr{
						pos:  position{line: 343, col: 7, offset: 9767},
						name: "IsPrimitive",
					},
					&ruleRefExpr{
						pos:  position{line: 344, col: 7, offset: 9785},
						name: "IsString",
					},
				},
			},
		},
		{
			name: "ArrayFunctions",
			pos:  position{line: 346, col: 1, offset: 9795},
			expr: &choiceExpr{
				pos: position{line: 346, col: 19, offset: 9813},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 346, col: 19, offset: 9813},
						name: "ArrayConcatExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 347, col: 7, offset: 9841},
						name: "ArrayLengthExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 348, col: 7, offset: 9869},
						name: "ArraySliceExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 349, col: 7, offset: 9896},
						name: "SetIntersectExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 350, col: 7, offset: 9925},
						name: "SetUnionExpression",
					},
				},
			},
		},
		{
			name: "UpperExpression",
			pos:  position{line: 352, col: 1, offset: 9945},
			expr: &actionExpr{
				pos: position{line: 352, col: 20, offset: 9964},
				run: (*parser).callonUpperExpression1,
				expr: &seqExpr{
					pos: position{line: 352, col: 20, offset: 9964},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 352, col: 20, offset: 9964},
							val:        "upper",
							ignoreCase: true,
							want:       "\"UPPER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 352, col: 29, offset: 9973},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 352, col: 32, offset: 9976},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&labeledExpr{
							pos:   position{line: 352, col: 36, offset: 9980},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 352, col: 39, offset: 9983},
								name: "SelectItem",
							},
						},
						&litMatcher{
							pos:        position{line: 352, col: 50, offset: 9994},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "LowerExpression",
			pos:  position{line: 356, col: 1, offset: 10079},
			expr: &actionExpr{
				pos: position{line: 356, col: 20, offset: 10098},
				run: (*parser).callonLowerExpression1,
				expr: &seqExpr{
					pos: position{line: 356, col: 20, offset: 10098},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 356, col: 20, offset: 10098},
							val:        "lower",
							ignoreCase: true,
							want:       "\"LOWER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 356, col: 29, offset: 10107},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 356, col: 32, offset: 10110},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&labeledExpr{
							pos:   position{line: 356, col: 36, offset: 10114},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 356, col: 39, offset: 10117},
								name: "SelectItem",
							},
						},
						&litMatcher{
							pos:        position{line: 356, col: 50, offset: 10128},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "StringEqualsExpression",
			pos:  position{line: 360, col: 1, offset: 10213},
			expr: &actionExpr{
				pos: position{line: 360, col: 27, offset: 10239},
				run: (*parser).callonStringEqualsExpression1,
				expr: &seqExpr{
					pos: position{line: 360, col: 27, offset: 10239},
					exprs: []any{
						&ruleRefExpr{
							pos:  position{line: 360, col: 27, offset: 10239},
							name: "StringEquals",
						},
						&ruleRefExpr{
							pos:  position{line: 360, col: 40, offset: 10252},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 360, col: 43, offset: 10255},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 360, col: 47, offset: 10259},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 360, col: 50, offset: 10262},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 360, col: 54, offset: 10266},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 360, col: 65, offset: 10277},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 360, col: 68, offset: 10280},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 360, col: 72, offset: 10284},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 360, col: 75, offset: 10287},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 360, col: 79, offset: 10291},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 360, col: 90, offset: 10302},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 360, col: 93, offset: 10305},
							label: "ignoreCase",
							expr: &zeroOrOneExpr{
								pos: position{line: 360, col: 104, offset: 10316},
								expr: &actionExpr{
									pos: position{line: 360, col: 105, offset: 10317},
									run: (*parser).callonStringEqualsExpression17,
									expr: &seqExpr{
										pos: position{line: 360, col: 105, offset: 10317},
										exprs: []any{
											&litMatcher{
												pos:        position{line: 360, col: 105, offset: 10317},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 360, col: 109, offset: 10321},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 360, col: 112, offset: 10324},
												label: "boolean",
												expr: &ruleRefExpr{
													pos:  position{line: 360, col: 120, offset: 10332},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&litMatcher{
							pos:        position{line: 360, col: 157, offset: 10369},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ToStringExpression",
			pos:  position{line: 364, col: 1, offset: 10479},
			expr: &actionExpr{
				pos: position{line: 364, col: 23, offset: 10501},
				run: (*parser).callonToStringExpression1,
				expr: &seqExpr{
					pos: position{line: 364, col: 23, offset: 10501},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 364, col: 23, offset: 10501},
							val:        "tostring",
							ignoreCase: true,
							want:       "\"TOSTRING\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 364, col: 35, offset: 10513},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 364, col: 38, offset: 10516},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 364, col: 42, offset: 10520},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 364, col: 45, offset: 10523},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 364, col: 48, offset: 10526},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 364, col: 59, offset: 10537},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 364, col: 62, offset: 10540},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ConcatExpression",
			pos:  position{line: 368, col: 1, offset: 10628},
			expr: &actionExpr{
				pos: position{line: 368, col: 21, offset: 10648},
				run: (*parser).callonConcatExpression1,
				expr: &seqExpr{
					pos: position{line: 368, col: 21, offset: 10648},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 368, col: 21, offset: 10648},
							val:        "concat",
							ignoreCase: true,
							want:       "\"CONCAT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 368, col: 31, offset: 10658},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 368, col: 34, offset: 10661},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 368, col: 38, offset: 10665},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 368, col: 41, offset: 10668},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 368, col: 45, offset: 10672},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 368, col: 56, offset: 10683},
							label: "others",
							expr: &oneOrMoreExpr{
								pos: position{line: 368, col: 63, offset: 10690},
								expr: &actionExpr{
									pos: position{line: 368, col: 64, offset: 10691},
									run: (*parser).callonConcatExpression11,
									expr: &seqExpr{
										pos: position{line: 368, col: 64, offset: 10691},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 368, col: 64, offset: 10691},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 368, col: 67, offset: 10694},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 368, col: 71, offset: 10698},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 368, col: 74, offset: 10701},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 368, col: 77, offset: 10704},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 368, col: 109, offset: 10736},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 368, col: 112, offset: 10739},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "LeftExpression",
			pos:  position{line: 373, col: 1, offset: 10888},
			expr: &actionExpr{
				pos: position{line: 373, col: 19, offset: 10906},
				run: (*parser).callonLeftExpression1,
				expr: &seqExpr{
					pos: position{line: 373, col: 19, offset: 10906},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 373, col: 19, offset: 10906},
							val:        "left",
							ignoreCase: true,
							want:       "\"LEFT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 373, col: 27, offset: 10914},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 373, col: 30, offset: 10917},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 373, col: 34, offset: 10921},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 373, col: 37, offset: 10924},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 373, col: 40, offset: 10927},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 373, col: 51, offset: 10938},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 373, col: 54, offset: 10941},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 373, col: 58, offset: 10945},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 373, col: 61, offset: 10948},
							label: "length",
							expr: &ruleRefExpr{
								pos:  position{line: 373, col: 68, offset: 10955},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 373, col: 79, offset: 10966},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 373, col: 82, offset: 10969},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "LengthExpression",
			pos:  position{line: 377, col: 1, offset: 11061},
			expr: &actionExpr{
				pos: position{line: 377, col: 21, offset: 11081},
				run: (*parser).callonLengthExpression1,
				expr: &seqExpr{
					pos: position{line: 377, col: 21, offset: 11081},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 377, col: 21, offset: 11081},
							val:        "length",
							ignoreCase: true,
							want:       "\"LENGTH\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 377, col: 31, offset: 11091},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 377, col: 34, offset: 11094},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 377, col: 38, offset: 11098},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 377, col: 41, offset: 11101},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 377, col: 44, offset: 11104},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 377, col: 55, offset: 11115},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 377, col: 58, offset: 11118},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "LTrimExpression",
			pos:  position{line: 381, col: 1, offset: 11204},
			expr: &actionExpr{
				pos: position{line: 381, col: 20, offset: 11223},
				run: (*parser).callonLTrimExpression1,
				expr: &seqExpr{
					pos: position{line: 381, col: 20, offset: 11223},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 381, col: 20, offset: 11223},
							val:        "ltrim",
							ignoreCase: true,
							want:       "\"LTRIM\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 381, col: 29, offset: 11232},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 381, col: 32, offset: 11235},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 381, col: 36, offset: 11239},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 381, col: 39, offset: 11242},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 381, col: 42, offset: 11245},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 381, col: 53, offset: 11256},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 381, col: 56, offset: 11259},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ReplaceExpression",
			pos:  position{line: 385, col: 1, offset: 11344},
			expr: &actionExpr{
				pos: position{line: 385, col: 22, offset: 11365},
				run: (*parser).callonReplaceExpression1,
				expr: &seqExpr{
					pos: position{line: 385, col: 22, offset: 11365},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 385, col: 22, offset: 11365},
							val:        "replace",
							ignoreCase: true,
							want:       "\"REPLACE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 385, col: 33, offset: 11376},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 385, col: 36, offset: 11379},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 385, col: 40, offset: 11383},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 385, col: 43, offset: 11386},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 385, col: 47, offset: 11390},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 385, col: 58, offset: 11401},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 385, col: 61, offset: 11404},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 385, col: 65, offset: 11408},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 385, col: 68, offset: 11411},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 385, col: 72, offset: 11415},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 385, col: 83, offset: 11426},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 385, col: 86, offset: 11429},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 385, col: 90, offset: 11433},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 385, col: 93, offset: 11436},
							label: "ex3",
							expr: &ruleRefExpr{
								pos:  position{line: 385, col: 97, offset: 11440},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 385, col: 108, offset: 11451},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 385, col: 111, offset: 11454},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ReplicateExpression",
			pos:  position{line: 389, col: 1, offset: 11552},
			expr: &actionExpr{
				pos: position{line: 389, col: 24, offset: 11575},
				run: (*parser).callonReplicateExpression1,
				expr: &seqExpr{
					pos: position{line: 389, col: 24, offset: 11575},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 389, col: 24, offset: 11575},
							val:        "replicate",
							ignoreCase: true,
							want:       "\"REPLICATE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 389, col: 37, offset: 11588},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 389, col: 40, offset: 11591},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 389, col: 44, offset: 11595},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 389, col: 47, offset: 11598},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 389, col: 51, offset: 11602},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 389, col: 62, offset: 11613},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 389, col: 65, offset: 11616},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 389, col: 69, offset: 11620},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 389, col: 72, offset: 11623},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 389, col: 76, offset: 11627},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 389, col: 87, offset: 11638},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 389, col: 90, offset: 11641},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ReverseExpression",
			pos:  position{line: 393, col: 1, offset: 11736},
			expr: &actionExpr{
				pos: position{line: 393, col: 22, offset: 11757},
				run: (*parser).callonReverseExpression1,
				expr: &seqExpr{
					pos: position{line: 393, col: 22, offset: 11757},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 393, col: 22, offset: 11757},
							val:        "reverse",
							ignoreCase: true,
							want:       "\"REVERSE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 393, col: 33, offset: 11768},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 393, col: 36, offset: 11771},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 393, col: 40, offset: 11775},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 393, col: 43, offset: 11778},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 393, col: 46, offset: 11781},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 393, col: 57, offset: 11792},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 393, col: 60, offset: 11795},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "RightExpression",
			pos:  position{line: 397, col: 1, offset: 11882},
			expr: &actionExpr{
				pos: position{line: 397, col: 20, offset: 11901},
				run: (*parser).callonRightExpression1,
				expr: &seqExpr{
					pos: position{line: 397, col: 20, offset: 11901},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 397, col: 20, offset: 11901},
							val:        "right",
							ignoreCase: true,
							want:       "\"RIGHT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 397, col: 29, offset: 11910},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 397, col: 32, offset: 11913},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 397, col: 36, offset: 11917},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 397, col: 39, offset: 11920},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 397, col: 42, offset: 11923},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 397, col: 53, offset: 11934},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 397, col: 56, offset: 11937},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 397, col: 60, offset: 11941},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 397, col: 63, offset: 11944},
							label: "length",
							expr: &ruleRefExpr{
								pos:  position{line: 397, col: 70, offset: 11951},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 397, col: 81, offset: 11962},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 397, col: 84, offset: 11965},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "RTrimExpression",
			pos:  position{line: 401, col: 1, offset: 12058},
			expr: &actionExpr{
				pos: position{line: 401, col: 20, offset: 12077},
				run: (*parser).callonRTrimExpression1,
				expr: &seqExpr{
					pos: position{line: 401, col: 20, offset: 12077},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 401, col: 20, offset: 12077},
							val:        "rtrim",
							ignoreCase: true,
							want:       "\"RTRIM\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 401, col: 29, offset: 12086},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 401, col: 32, offset: 12089},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 401, col: 36, offset: 12093},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 401, col: 39, offset: 12096},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 401, col: 42, offset: 12099},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 401, col: 53, offset: 12110},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 401, col: 56, offset: 12113},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "SubstringExpression",
			pos:  position{line: 405, col: 1, offset: 12198},
			expr: &actionExpr{
				pos: position{line: 405, col: 24, offset: 12221},
				run: (*parser).callonSubstringExpression1,
				expr: &seqExpr{
					pos: position{line: 405, col: 24, offset: 12221},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 405, col: 24, offset: 12221},
							val:        "substring",
							ignoreCase: true,
							want:       "\"SUBSTRING\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 405, col: 37, offset: 12234},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 405, col: 40, offset: 12237},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 405, col: 44, offset: 12241},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 405, col: 47, offset: 12244},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 405, col: 50, offset: 12247},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 405, col: 61, offset: 12258},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 405, col: 64, offset: 12261},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 405, col: 68, offset: 12265},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 405, col: 71, offset: 12268},
							label: "startPos",
							expr: &ruleRefExpr{
								pos:  position{line: 405, col: 80, offset: 12277},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 405, col: 91, offset: 12288},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 405, col: 94, offset: 12291},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 405, col: 98, offset: 12295},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 405, col: 101, offset: 12298},
							label: "length",
							expr: &ruleRefExpr{
								pos:  position{line: 405, col: 108, offset: 12305},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 405, col: 119, offset: 12316},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 405, col: 122, offset: 12319},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "TrimExpression",
			pos:  position{line: 409, col: 1, offset: 12426},
			expr: &actionExpr{
				pos: position{line: 409, col: 19, offset: 12444},
				run: (*parser).callonTrimExpression1,
				expr: &seqExpr{
					pos: position{line: 409, col: 19, offset: 12444},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 409, col: 19, offset: 12444},
							val:        "trim",
							ignoreCase: true,
							want:       "\"TRIM\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 409, col: 27, offset: 12452},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 409, col: 30, offset: 12455},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 409, col: 34, offset: 12459},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 409, col: 37, offset: 12462},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 409, col: 40, offset: 12465},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 409, col: 51, offset: 12476},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 409, col: 54, offset: 12479},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ThreeArgumentStringFunctionExpression",
			pos:  position{line: 413, col: 1, offset: 12563},
			expr: &actionExpr{
				pos: position{line: 413, col: 42, offset: 12604},
				run: (*parser).callonThreeArgumentStringFunctionExpression1,
				expr: &seqExpr{
					pos: position{line: 413, col: 42, offset: 12604},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 413, col: 42, offset: 12604},
							label: "function",
							expr: &ruleRefExpr{
								pos:  position{line: 413, col: 51, offset: 12613},
								name: "ThreeArgumentStringFunction",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 413, col: 79, offset: 12641},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 413, col: 82, offset: 12644},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 413, col: 86, offset: 12648},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 413, col: 89, offset: 12651},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 413, col: 93, offset: 12655},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 413, col: 104, offset: 12666},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 413, col: 107, offset: 12669},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 413, col: 111, offset: 12673},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 413, col: 114, offset: 12676},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 413, col: 118, offset: 12680},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 413, col: 129, offset: 12691},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 413, col: 132, offset: 12694},
							label: "ignoreCase",
							expr: &zeroOrOneExpr{
								pos: position{line: 413, col: 143, offset: 12705},
								expr: &actionExpr{
									pos: position{line: 413, col: 144, offset: 12706},
									run: (*parser).callonThreeArgumentStringFunctionExpression18,
									expr: &seqExpr{
										pos: position{line: 413, col: 144, offset: 12706},
										exprs: []any{
											&litMatcher{
												pos:        position{line: 413, col: 144, offset: 12706},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 413, col: 148, offset: 12710},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 413, col: 151, offset: 12713},
												label: "boolean",
												expr: &ruleRefExpr{
													pos:  position{line: 413, col: 159, offset: 12721},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&litMatcher{
							pos:        position{line: 413, col: 196, offset: 12758},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ThreeArgumentStringFunction",
			pos:  position{line: 431, col: 1, offset: 13304},
			expr: &actionExpr{
				pos: position{line: 431, col: 32, offset: 13335},
				run: (*parser).callonThreeArgumentStringFunction1,
				expr: &choiceExpr{
					pos: position{line: 431, col: 33, offset: 13336},
					alternatives: []any{
						&litMatcher{
							pos:        position{line: 431, col: 33, offset: 13336},
							val:        "contains",
							ignoreCase: true,
							want:       "\"CONTAINS\"i",
						},
						&litMatcher{
							pos:        position{line: 431, col: 47, offset: 13350},
							val:        "endswith",
							ignoreCase: true,
							want:       "\"ENDSWITH\"i",
						},
						&litMatcher{
							pos:        position{line: 431, col: 61, offset: 13364},
							val:        "startswith",
							ignoreCase: true,
							want:       "\"STARTSWITH\"i",
						},
						&litMatcher{
							pos:        position{line: 431, col: 77, offset: 13380},
							val:        "index_of",
							ignoreCase: true,
							want:       "\"INDEX_OF\"i",
						},
					},
				},
			},
		},
		{
			name: "IsDefined",
			pos:  position{line: 435, col: 1, offset: 13429},
			expr: &actionExpr{
				pos: position{line: 435, col: 14, offset: 13442},
				run: (*parser).callonIsDefined1,
				expr: &seqExpr{
					pos: position{line: 435, col: 14, offset: 13442},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 435, col: 14, offset: 13442},
							val:        "is_defined",
							ignoreCase: true,
							want:       "\"IS_DEFINED\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 435, col: 28, offset: 13456},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 435, col: 31, offset: 13459},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 435, col: 35, offset: 13463},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 435, col: 38, offset: 13466},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 435, col: 41, offset: 13469},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 435, col: 52, offset: 13480},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 435, col: 55, offset: 13483},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsArray",
			pos:  position{line: 439, col: 1, offset: 13572},
			expr: &actionExpr{
				pos: position{line: 439, col: 12, offset: 13583},
				run: (*parser).callonIsArray1,
				expr: &seqExpr{
					pos: position{line: 439, col: 12, offset: 13583},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 439, col: 12, offset: 13583},
							val:        "is_array",
							ignoreCase: true,
							want:       "\"IS_ARRAY\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 439, col: 24, offset: 13595},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 439, col: 27, offset: 13598},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 439, col: 31, offset: 13602},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 439, col: 34, offset: 13605},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 439, col: 37, offset: 13608},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 439, col: 48, offset: 13619},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 439, col: 51, offset: 13622},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsBool",
			pos:  position{line: 443, col: 1, offset: 13709},
			expr: &actionExpr{
				pos: position{line: 443, col: 11, offset: 13719},
				run: (*parser).callonIsBool1,
				expr: &seqExpr{
					pos: position{line: 443, col: 11, offset: 13719},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 443, col: 11, offset: 13719},
							val:        "is_bool",
							ignoreCase: true,
							want:       "\"IS_BOOL\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 443, col: 22, offset: 13730},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 443, col: 25, offset: 13733},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 443, col: 29, offset: 13737},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 443, col: 32, offset: 13740},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 443, col: 35, offset: 13743},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 443, col: 46, offset: 13754},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 443, col: 49, offset: 13757},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsFiniteNumber",
			pos:  position{line: 447, col: 1, offset: 13843},
			expr: &actionExpr{
				pos: position{line: 447, col: 19, offset: 13861},
				run: (*parser).callonIsFiniteNumber1,
				expr: &seqExpr{
					pos: position{line: 447, col: 19, offset: 13861},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 447, col: 19, offset: 13861},
							val:        "is_finite_number",
							ignoreCase: true,
							want:       "\"IS_FINITE_NUMBER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 447, col: 39, offset: 13881},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 447, col: 42, offset: 13884},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 447, col: 46, offset: 13888},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 447, col: 49, offset: 13891},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 447, col: 52, offset: 13894},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 447, col: 63, offset: 13905},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 447, col: 66, offset: 13908},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsInteger",
			pos:  position{line: 451, col: 1, offset: 14002},
			expr: &actionExpr{
				pos: position{line: 451, col: 14, offset: 14015},
				run: (*parser).callonIsInteger1,
				expr: &seqExpr{
					pos: position{line: 451, col: 14, offset: 14015},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 451, col: 14, offset: 14015},
							val:        "is_integer",
							ignoreCase: true,
							want:       "\"IS_INTEGER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 451, col: 28, offset: 14029},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 451, col: 31, offset: 14032},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 451, col: 35, offset: 14036},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 451, col: 38, offset: 14039},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 451, col: 41, offset: 14042},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 451, col: 52, offset: 14053},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 451, col: 55, offset: 14056},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsNull",
			pos:  position{line: 455, col: 1, offset: 14145},
			expr: &actionExpr{
				pos: position{line: 455, col: 11, offset: 14155},
				run: (*parser).callonIsNull1,
				expr: &seqExpr{
					pos: position{line: 455, col: 11, offset: 14155},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 455, col: 11, offset: 14155},
							val:        "is_null",
							ignoreCase: true,
							want:       "\"IS_NULL\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 455, col: 22, offset: 14166},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 455, col: 25, offset: 14169},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 455, col: 29, offset: 14173},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 455, col: 32, offset: 14176},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 455, col: 35, offset: 14179},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 455, col: 46, offset: 14190},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 455, col: 49, offset: 14193},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsNumber",
			pos:  position{line: 459, col: 1, offset: 14279},
			expr: &actionExpr{
				pos: position{line: 459, col: 13, offset: 14291},
				run: (*parser).callonIsNumber1,
				expr: &seqExpr{
					pos: position{line: 459, col: 13, offset: 14291},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 459, col: 13, offset: 14291},
							val:        "is_number",
							ignoreCase: true,
							want:       "\"IS_NUMBER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 459, col: 26, offset: 14304},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 459, col: 29, offset: 14307},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 459, col: 33, offset: 14311},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 459, col: 36, offset: 14314},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 459, col: 39, offset: 14317},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 459, col: 50, offset: 14328},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 459, col: 53, offset: 14331},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsObject",
			pos:  position{line: 463, col: 1, offset: 14419},
			expr: &actionExpr{
				pos: position{line: 463, col: 13, offset: 14431},
				run: (*parser).callonIsObject1,
				expr: &seqExpr{
					pos: position{line: 463, col: 13, offset: 14431},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 463, col: 13, offset: 14431},
							val:        "is_object",
							ignoreCase: true,
							want:       "\"IS_OBJECT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 463, col: 26, offset: 14444},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 463, col: 29, offset: 14447},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 463, col: 33, offset: 14451},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 463, col: 36, offset: 14454},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 463, col: 39, offset: 14457},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 463, col: 50, offset: 14468},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 463, col: 53, offset: 14471},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsPrimitive",
			pos:  position{line: 467, col: 1, offset: 14559},
			expr: &actionExpr{
				pos: position{line: 467, col: 16, offset: 14574},
				run: (*parser).callonIsPrimitive1,
				expr: &seqExpr{
					pos: position{line: 467, col: 16, offset: 14574},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 467, col: 16, offset: 14574},
							val:        "is_primitive",
							ignoreCase: true,
							want:       "\"IS_PRIMITIVE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 467, col: 32, offset: 14590},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 467, col: 35, offset: 14593},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 467, col: 39, offset: 14597},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 467, col: 42, offset: 14600},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 467, col: 45, offset: 14603},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 467, col: 56, offset: 14614},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 467, col: 59, offset: 14617},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsString",
			pos:  position{line: 471, col: 1, offset: 14708},
			expr: &actionExpr{
				pos: position{line: 471, col: 13, offset: 14720},
				run: (*parser).callonIsString1,
				expr: &seqExpr{
					pos: position{line: 471, col: 13, offset: 14720},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 471, col: 13, offset: 14720},
							val:        "is_string",
							ignoreCase: true,
							want:       "\"IS_STRING\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 471, col: 26, offset: 14733},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 471, col: 29, offset: 14736},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 471, col: 33, offset: 14740},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 471, col: 36, offset: 14743},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 471, col: 39, offset: 14746},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 471, col: 50, offset: 14757},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 471, col: 53, offset: 14760},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ArrayConcatExpression",
			pos:  position{line: 475, col: 1, offset: 14848},
			expr: &actionExpr{
				pos: position{line: 475, col: 26, offset: 14873},
				run: (*parser).callonArrayConcatExpression1,
				expr: &seqExpr{
					pos: position{line: 475, col: 26, offset: 14873},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 475, col: 26, offset: 14873},
							val:        "array_concat",
							ignoreCase: true,
							want:       "\"ARRAY_CONCAT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 475, col: 42, offset: 14889},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 475, col: 45, offset: 14892},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 475, col: 49, offset: 14896},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 475, col: 52, offset: 14899},
							label: "arrays",
							expr: &ruleRefExpr{
								pos:  position{line: 475, col: 59, offset: 14906},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 475, col: 70, offset: 14917},
							label: "others",
							expr: &oneOrMoreExpr{
								pos: position{line: 475, col: 77, offset: 14924},
								expr: &actionExpr{
									pos: position{line: 475, col: 78, offset: 14925},
									run: (*parser).callonArrayConcatExpression11,
									expr: &seqExpr{
										pos: position{line: 475, col: 78, offset: 14925},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 475, col: 78, offset: 14925},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 475, col: 81, offset: 14928},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 475, col: 85, offset: 14932},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 475, col: 88, offset: 14935},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 475, col: 91, offset: 14938},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 475, col: 123, offset: 14970},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 475, col: 126, offset: 14973},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ArrayLengthExpression",
			pos:  position{line: 479, col: 1, offset: 15103},
			expr: &actionExpr{
				pos: position{line: 479, col: 26, offset: 15128},
				run: (*parser).callonArrayLengthExpression1,
				expr: &seqExpr{
					pos: position{line: 479, col: 26, offset: 15128},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 479, col: 26, offset: 15128},
							val:        "array_length",
							ignoreCase: true,
							want:       "\"ARRAY_LENGTH\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 479, col: 42, offset: 15144},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 479, col: 45, offset: 15147},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 479, col: 49, offset: 15151},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 479, col: 52, offset: 15154},
							label: "array",
							expr: &ruleRefExpr{
								pos:  position{line: 479, col: 58, offset: 15160},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 479, col: 69, offset: 15171},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 479, col: 72, offset: 15174},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ArraySliceExpression",
			pos:  position{line: 483, col: 1, offset: 15268},
			expr: &actionExpr{
				pos: position{line: 483, col: 25, offset: 15292},
				run: (*parser).callonArraySliceExpression1,
				expr: &seqExpr{
					pos: position{line: 483, col: 25, offset: 15292},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 483, col: 25, offset: 15292},
							val:        "array_slice",
							ignoreCase: true,
							want:       "\"ARRAY_SLICE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 483, col: 40, offset: 15307},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 483, col: 43, offset: 15310},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 483, col: 47, offset: 15314},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 483, col: 50, offset: 15317},
							label: "array",
							expr: &ruleRefExpr{
								pos:  position{line: 483, col: 56, offset: 15323},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 483, col: 67, offset: 15334},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 483, col: 70, offset: 15337},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 483, col: 74, offset: 15341},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 483, col: 77, offset: 15344},
							label: "start",
							expr: &ruleRefExpr{
								pos:  position{line: 483, col: 83, offset: 15350},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 483, col: 94, offset: 15361},
							label: "length",
							expr: &zeroOrOneExpr{
								pos: position{line: 483, col: 101, offset: 15368},
								expr: &actionExpr{
									pos: position{line: 483, col: 102, offset: 15369},
									run: (*parser).callonArraySliceExpression16,
									expr: &seqExpr{
										pos: position{line: 483, col: 102, offset: 15369},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 483, col: 102, offset: 15369},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 483, col: 105, offset: 15372},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 483, col: 109, offset: 15376},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 483, col: 112, offset: 15379},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 483, col: 115, offset: 15382},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 483, col: 147, offset: 15414},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 483, col: 150, offset: 15417},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "SetIntersectExpression",
			pos:  position{line: 487, col: 1, offset: 15525},
			expr: &actionExpr{
				pos: position{line: 487, col: 27, offset: 15551},
				run: (*parser).callonSetIntersectExpression1,
				expr: &seqExpr{
					pos: position{line: 487, col: 27, offset: 15551},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 487, col: 27, offset: 15551},
							val:        "setintersect",
							ignoreCase: true,
							want:       "\"SetIntersect\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 487, col: 43, offset: 15567},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 487, col: 46, offset: 15570},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 487, col: 50, offset: 15574},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 487, col: 53, offset: 15577},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 487, col: 58, offset: 15582},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 487, col: 69, offset: 15593},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 487, col: 72, offset: 15596},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 487, col: 76, offset: 15600},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 487, col: 79, offset: 15603},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 487, col: 84, offset: 15608},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 487, col: 95, offset: 15619},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 487, col: 98, offset: 15622},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "SetUnionExpression",
			pos:  position{line: 491, col: 1, offset: 15722},
			expr: &actionExpr{
				pos: position{line: 491, col: 23, offset: 15744},
				run: (*parser).callonSetUnionExpression1,
				expr: &seqExpr{
					pos: position{line: 491, col: 23, offset: 15744},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 491, col: 23, offset: 15744},
							val:        "setunion",
							ignoreCase: true,
							want:       "\"SetUnion\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 491, col: 35, offset: 15756},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 491, col: 38, offset: 15759},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 491, col: 42, offset: 15763},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 491, col: 45, offset: 15766},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 491, col: 50, offset: 15771},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 491, col: 61, offset: 15782},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 491, col: 64, offset: 15785},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 491, col: 68, offset: 15789},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 491, col: 71, offset: 15792},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 491, col: 76, offset: 15797},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 491, col: 87, offset: 15808},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 491, col: 90, offset: 15811},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "InFunction",
			pos:  position{line: 495, col: 1, offset: 15907},
			expr: &actionExpr{
				pos: position{line: 495, col: 15, offset: 15921},
				run: (*parser).callonInFunction1,
				expr: &seqExpr{
					pos: position{line: 495, col: 15, offset: 15921},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 495, col: 15, offset: 15921},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 495, col: 19, offset: 15925},
								name: "SelectProperty",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 495, col: 34, offset: 15940},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 495, col: 37, offset: 15943},
							val:        "in",
							ignoreCase: true,
							want:       "\"IN\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 495, col: 43, offset: 15949},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 495, col: 46, offset: 15952},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 495, col: 50, offset: 15956},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 495, col: 53, offset: 15959},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 495, col: 57, offset: 15963},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 495, col: 68, offset: 15974},
							label: "others",
							expr: &zeroOrMoreExpr{
								pos: position{line: 495, col: 75, offset: 15981},
								expr: &actionExpr{
									pos: position{line: 495, col: 76, offset: 15982},
									run: (*parser).callonInFunction14,
									expr: &seqExpr{
										pos: position{line: 495, col: 76, offset: 15982},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 495, col: 76, offset: 15982},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 495, col: 79, offset: 15985},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 495, col: 83, offset: 15989},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 495, col: 86, offset: 15992},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 495, col: 89, offset: 15995},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 495, col: 121, offset: 16027},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 495, col: 124, offset: 16030},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "Integer",
			pos:  position{line: 500, col: 1, offset: 16204},
			expr: &actionExpr{
				pos: position{line: 500, col: 12, offset: 16215},
				run: (*parser).callonInteger1,
				expr: &oneOrMoreExpr{
					pos: position{line: 500, col: 12, offset: 16215},
					expr: &charClassMatcher{
						pos:        position{line: 500, col: 12, offset: 16215},
						val:        "[0-9]",
						ranges:     []rune{'0', '9'},
						ignoreCase: false,
						inverted:   false,
					},
				},
			},
		},
		{
			name: "StringCharacter",
			pos:  position{line: 504, col: 1, offset: 16267},
			expr: &choiceExpr{
				pos: position{line: 504, col: 20, offset: 16286},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 504, col: 20, offset: 16286},
						run: (*parser).callonStringCharacter2,
						expr: &seqExpr{
							pos: position{line: 504, col: 20, offset: 16286},
							exprs: []any{
								&notExpr{
									pos: position{line: 504, col: 20, offset: 16286},
									expr: &choiceExpr{
										pos: position{line: 504, col: 22, offset: 16288},
										alternatives: []any{
											&litMatcher{
												pos:        position{line: 504, col: 22, offset: 16288},
												val:        "\"",
												ignoreCase: false,
												want:       "\"\\\"\"",
											},
											&litMatcher{
												pos:        position{line: 504, col: 28, offset: 16294},
												val:        "\\",
												ignoreCase: false,
												want:       "\"\\\\\"",
											},
										},
									},
								},
								&anyMatcher{
									line: 504, col: 34, offset: 16300,
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 505, col: 5, offset: 16337},
						run: (*parser).callonStringCharacter9,
						expr: &seqExpr{
							pos: position{line: 505, col: 5, offset: 16337},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 505, col: 5, offset: 16337},
									val:        "\\",
									ignoreCase: false,
									want:       "\"\\\\\"",
								},
								&labeledExpr{
									pos:   position{line: 505, col: 10, offset: 16342},
									label: "seq",
									expr: &ruleRefExpr{
										pos:  position{line: 505, col: 14, offset: 16346},
										name: "EscapeSequenceCharacter",
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "EscapeSequenceCharacter",
			pos:  position{line: 507, col: 1, offset: 16391},
			expr: &labeledExpr{
				pos:   position{line: 507, col: 28, offset: 16418},
				label: "char",
				expr: &ruleRefExpr{
					pos:  position{line: 507, col: 33, offset: 16423},
					name: "EscapeCharacter",
				},
			},
		},
		{
			name: "EscapeCharacter",
			pos:  position{line: 509, col: 1, offset: 16440},
			expr: &choiceExpr{
				pos: position{line: 509, col: 20, offset: 16459},
				alternatives: []any{
					&litMatcher{
						pos:        position{line: 509, col: 20, offset: 16459},
						val:        "'",
						ignoreCase: false,
						want:       "\"'\"",
					},
					&litMatcher{
						pos:        position{line: 510, col: 5, offset: 16467},
						val:        "\"",
						ignoreCase: false,
						want:       "\"\\\"\"",
					},
					&litMatcher{
						pos:        position{line: 511, col: 5, offset: 16475},
						val:        "\\",
						ignoreCase: false,
						want:       "\"\\\\\"",
					},
					&actionExpr{
						pos: position{line: 512, col: 5, offset: 16484},
						run: (*parser).callonEscapeCharacter5,
						expr: &litMatcher{
							pos:        position{line: 512, col: 5, offset: 16484},
							val:        "b",
							ignoreCase: false,
							want:       "\"b\"",
						},
					},
					&actionExpr{
						pos: position{line: 513, col: 5, offset: 16513},
						run: (*parser).callonEscapeCharacter7,
						expr: &litMatcher{
							pos:        position{line: 513, col: 5, offset: 16513},
							val:        "f",
							ignoreCase: false,
							want:       "\"f\"",
						},
					},
					&actionExpr{
						pos: position{line: 514, col: 5, offset: 16542},
						run: (*parser).callonEscapeCharacter9,
						expr: &litMatcher{
							pos:        position{line: 514, col: 5, offset: 16542},
							val:        "n",
							ignoreCase: false,
							want:       "\"n\"",
						},
					},
					&actionExpr{
						pos: position{line: 515, col: 5, offset: 16571},
						run: (*parser).callonEscapeCharacter11,
						expr: &litMatcher{
							pos:        position{line: 515, col: 5, offset: 16571},
							val:        "r",
							ignoreCase: false,
							want:       "\"r\"",
						},
					},
					&actionExpr{
						pos: position{line: 516, col: 5, offset: 16600},
						run: (*parser).callonEscapeCharacter13,
						expr: &litMatcher{
							pos:        position{line: 516, col: 5, offset: 16600},
							val:        "t",
							ignoreCase: false,
							want:       "\"t\"",
						},
					},
				},
			},
		},
		{
			name: "non_escape_character",
			pos:  position{line: 518, col: 1, offset: 16626},
			expr: &actionExpr{
				pos: position{line: 518, col: 25, offset: 16650},
				run: (*parser).callonnon_escape_character1,
				expr: &seqExpr{
					pos: position{line: 518, col: 25, offset: 16650},
					exprs: []any{
						&notExpr{
							pos: position{line: 518, col: 25, offset: 16650},
							expr: &ruleRefExpr{
								pos:  position{line: 518, col: 27, offset: 16652},
								name: "escape_character",
							},
						},
						&labeledExpr{
							pos:   position{line: 518, col: 45, offset: 16670},
							label: "char",
							expr: &anyMatcher{
								line: 518, col: 50, offset: 16675,
							},
						},
					},
				},
			},
		},
		{
			name: "ws",
			pos:  position{line: 521, col: 1, offset: 16714},
			expr: &zeroOrMoreExpr{
				pos: position{line: 521, col: 7, offset: 16720},
				expr: &charClassMatcher{
					pos:        position{line: 521, col: 7, offset: 16720},
					val:        "[ \\t\\n\\r]",
					chars:      []rune{' ', '\t', '\n', '\r'},
					ignoreCase: false,
					inverted:   false,
				},
			},
		},
		{
			name: "EOF",
			pos:  position{line: 523, col: 1, offset: 16732},
			expr: &notExpr{
				pos: position{line: 523, col: 8, offset: 16739},
				expr: &anyMatcher{
					line: 523, col: 9, offset: 16740,
				},
			},
		},
	},
}

func (c *current) onInput1(selectStmt any) (any, error) {
	return selectStmt, nil
}

func (p *parser) callonInput1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInput1(stack["selectStmt"])
}

func (c *current) onSelectStmt19(condition any) (any, error) {
	return condition, nil
}

func (p *parser) callonSelectStmt19() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt19(stack["condition"])
}

func (c *current) onSelectStmt1(topClause, columns, table, whereClause, orderByClause any) (any, error) {
	return makeSelectStmt(columns, table, whereClause, topClause, orderByClause)
}

func (p *parser) callonSelectStmt1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt1(stack["topClause"], stack["columns"], stack["table"], stack["whereClause"], stack["orderByClause"])
}

func (c *current) onTopClause1(count any) (any, error) {
	return count, nil
}

func (p *parser) callonTopClause1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onTopClause1(stack["count"])
}

func (c *current) onSelectAsterisk1() (any, error) {
	selectItem, _ := makeSelectItem("c", make([]interface{}, 0), parsers.SelectItemTypeField)
	selectItem.IsTopLevel = true
	return makeColumnList(selectItem, make([]interface{}, 0))
}

func (p *parser) callonSelectAsterisk1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectAsterisk1()
}

func (c *current) onColumnList7(coll any) (any, error) {
	return coll, nil
}

func (p *parser) callonColumnList7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onColumnList7(stack["coll"])
}

func (c *current) onColumnList1(column, other_columns any) (any, error) {
	return makeColumnList(column, other_columns)
}

func (p *parser) callonColumnList1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onColumnList1(stack["column"], stack["other_columns"])
}

func (c *current) onSelectValueSpec1(column any) (any, error) {
	selectItem := column.(parsers.SelectItem)
	selectItem.IsTopLevel = true
	return makeColumnList(selectItem, make([]interface{}, 0))
}

func (p *parser) callonSelectValueSpec1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectValueSpec1(stack["column"])
}

func (c *current) onTableName1(key any) (any, error) {
	return parsers.Table{Value: key.(string)}, nil
}

func (p *parser) callonTableName1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onTableName1(stack["key"])
}

func (c *current) onSelectArray1(columns any) (any, error) {
	return makeSelectArray(columns)
}

func (p *parser) callonSelectArray1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectArray1(stack["columns"])
}

func (c *current) onSelectObject10(coll any) (any, error) {
	return coll, nil
}

func (p *parser) callonSelectObject10() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectObject10(stack["coll"])
}

func (c *current) onSelectObject1(field, other_fields any) (any, error) {
	return makeSelectObject(field, other_fields)
}

func (p *parser) callonSelectObject1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectObject1(stack["field"], stack["other_fields"])
}

func (c *current) onSelectObjectField6(key any) (any, error) {
	return key, nil
}

func (p *parser) callonSelectObjectField6() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectObjectField6(stack["key"])
}

func (c *current) onSelectObjectField1(name, selectItem any) (any, error) {
	item := selectItem.(parsers.SelectItem)
	item.Alias = name.(string)
	return item, nil
}

func (p *parser) callonSelectObjectField1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectObjectField1(stack["name"], stack["selectItem"])
}

func (c *current) onSelectProperty1(name, path any) (any, error) {
	return makeSelectItem(name, path, parsers.SelectItemTypeField)
}

func (p *parser) callonSelectProperty1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectProperty1(stack["name"], stack["path"])
}

func (c *current) onSelectItem1(selectItem, asClause any) (any, error) {
	var itemResult parsers.SelectItem
	switch typedValue := selectItem.(type) {
	case parsers.SelectItem:
		itemResult = typedValue
	case parsers.Constant:
		itemResult = parsers.SelectItem{
			Type:  parsers.SelectItemTypeConstant,
			Value: typedValue,
		}
	case parsers.FunctionCall:
		itemResult = parsers.SelectItem{
			Type:  parsers.SelectItemTypeFunctionCall,
			Value: typedValue,
		}
	}

	if aliasValue, ok := asClause.(string); ok {
		itemResult.Alias = aliasValue
	}

	return itemResult, nil
}

func (p *parser) callonSelectItem1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectItem1(stack["selectItem"], stack["asClause"])
}

func (c *current) onAsClause1(alias any) (any, error) {
	return alias, nil
}

func (p *parser) callonAsClause1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onAsClause1(stack["alias"])
}

func (c *current) onDotFieldAccess1(id any) (any, error) {
	return id, nil
}

func (p *parser) callonDotFieldAccess1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onDotFieldAccess1(stack["id"])
}

func (c *current) onArrayFieldAccess1(id any) (any, error) {
	return id, nil
}

func (p *parser) callonArrayFieldAccess1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayFieldAccess1(stack["id"])
}

func (c *current) onIdentifier1() (any, error) {
	return string(c.text), nil
}

func (p *parser) callonIdentifier1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIdentifier1()
}

func (c *current) onCondition1(expression any) (any, error) {
	return expression, nil
}

func (p *parser) callonCondition1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onCondition1(stack["expression"])
}

func (c *current) onOrExpression7(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonOrExpression7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrExpression7(stack["ex"])
}

func (c *current) onOrExpression1(ex1, ex2 any) (any, error) {
	return combineExpressions(ex1, ex2, parsers.LogicalExpressionTypeOr)
}

func (p *parser) callonOrExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrExpression1(stack["ex1"], stack["ex2"])
}

func (c *current) onAndExpression7(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonAndExpression7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onAndExpression7(stack["ex"])
}

func (c *current) onAndExpression1(ex1, ex2 any) (any, error) {
	return combineExpressions(ex1, ex2, parsers.LogicalExpressionTypeAnd)
}

func (p *parser) callonAndExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onAndExpression1(stack["ex1"], stack["ex2"])
}

func (c *current) onComparisonExpression2(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonComparisonExpression2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonExpression2(stack["ex"])
}

func (c *current) onComparisonExpression10(left, op, right any) (any, error) {
	return parsers.ComparisonExpression{Left: left, Right: right, Operation: op.(string)}, nil
}

func (p *parser) callonComparisonExpression10() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonExpression10(stack["left"], stack["op"], stack["right"])
}

func (c *current) onComparisonExpression20(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonComparisonExpression20() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonExpression20(stack["ex"])
}

func (c *current) onComparisonExpression23(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonComparisonExpression23() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonExpression23(stack["ex"])
}

func (c *current) onOrderByClause9(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonOrderByClause9() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrderByClause9(stack["ex"])
}

func (c *current) onOrderByClause1(ex1, others any) (any, error) {
	return makeOrderByClause(ex1, others)
}

func (p *parser) callonOrderByClause1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrderByClause1(stack["ex1"], stack["others"])
}

func (c *current) onOrderExpression1(field, order any) (any, error) {
	return makeOrderExpression(field, order)
}

func (p *parser) callonOrderExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrderExpression1(stack["field"], stack["order"])
}

func (c *current) onOrderDirection1() (any, error) {
	if strings.EqualFold(string(c.text), "DESC") {
		return parsers.OrderDirectionDesc, nil
	}

	return parsers.OrderDirectionAsc, nil
}

func (p *parser) callonOrderDirection1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrderDirection1()
}

func (c *current) onComparisonOperator1() (any, error) {
	return string(c.text), nil
}

func (p *parser) callonComparisonOperator1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonOperator1()
}

func (c *current) onParameterConstant1() (any, error) {
	return parsers.Constant{Type: parsers.ConstantTypeParameterConstant, Value: string(c.text)}, nil
}

func (p *parser) callonParameterConstant1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onParameterConstant1()
}

func (c *current) onNullConstant1() (any, error) {
	return parsers.Constant{Value: nil}, nil
}

func (p *parser) callonNullConstant1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onNullConstant1()
}

func (c *current) onIntegerLiteral1(number any) (any, error) {
	return parsers.Constant{Type: parsers.ConstantTypeInteger, Value: number.(int)}, nil
}

func (p *parser) callonIntegerLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIntegerLiteral1(stack["number"])
}

func (c *current) onStringLiteral1(chars any) (any, error) {
	return parsers.Constant{Type: parsers.ConstantTypeString, Value: joinStrings(chars.([]interface{}))}, nil
}

func (p *parser) callonStringLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringLiteral1(stack["chars"])
}

func (c *current) onFloatLiteral1() (any, error) {
	floatValue, _ := strconv.ParseFloat(string(c.text), 64)
	return parsers.Constant{Type: parsers.ConstantTypeFloat, Value: floatValue}, nil
}

func (p *parser) callonFloatLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onFloatLiteral1()
}

func (c *current) onBooleanLiteral1() (any, error) {
	boolValue, _ := strconv.ParseBool(string(c.text))
	return parsers.Constant{Type: parsers.ConstantTypeBoolean, Value: boolValue}, nil
}

func (p *parser) callonBooleanLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onBooleanLiteral1()
}

func (c *current) onUpperExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallUpper, []interface{}{ex})
}

func (p *parser) callonUpperExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onUpperExpression1(stack["ex"])
}

func (c *current) onLowerExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallLower, []interface{}{ex})
}

func (p *parser) callonLowerExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onLowerExpression1(stack["ex"])
}

func (c *current) onStringEqualsExpression17(boolean any) (any, error) {
	return boolean, nil
}

func (p *parser) callonStringEqualsExpression17() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringEqualsExpression17(stack["boolean"])
}

func (c *current) onStringEqualsExpression1(ex1, ex2, ignoreCase any) (any, error) {
	return createFunctionCall(parsers.FunctionCallStringEquals, []interface{}{ex1, ex2, ignoreCase})
}

func (p *parser) callonStringEqualsExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringEqualsExpression1(stack["ex1"], stack["ex2"], stack["ignoreCase"])
}

func (c *current) onToStringExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallToString, []interface{}{ex})
}

func (p *parser) callonToStringExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onToStringExpression1(stack["ex"])
}

func (c *current) onConcatExpression11(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonConcatExpression11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onConcatExpression11(stack["ex"])
}

func (c *current) onConcatExpression1(ex1, others any) (any, error) {
	arguments := append([]interface{}{ex1}, others.([]interface{})...)
	return createFunctionCall(parsers.FunctionCallConcat, arguments)
}

func (p *parser) callonConcatExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onConcatExpression1(stack["ex1"], stack["others"])
}

func (c *current) onLeftExpression1(ex, length any) (any, error) {
	return createFunctionCall(parsers.FunctionCallLeft, []interface{}{ex, length})
}

func (p *parser) callonLeftExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onLeftExpression1(stack["ex"], stack["length"])
}

func (c *current) onLengthExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallLength, []interface{}{ex})
}

func (p *parser) callonLengthExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onLengthExpression1(stack["ex"])
}

func (c *current) onLTrimExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallLTrim, []interface{}{ex})
}

func (p *parser) callonLTrimExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onLTrimExpression1(stack["ex"])
}

func (c *current) onReplaceExpression1(ex1, ex2, ex3 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallReplace, []interface{}{ex1, ex2, ex3})
}

func (p *parser) callonReplaceExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onReplaceExpression1(stack["ex1"], stack["ex2"], stack["ex3"])
}

func (c *current) onReplicateExpression1(ex1, ex2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallReplicate, []interface{}{ex1, ex2})
}

func (p *parser) callonReplicateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onReplicateExpression1(stack["ex1"], stack["ex2"])
}

func (c *current) onReverseExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallReverse, []interface{}{ex})
}

func (p *parser) callonReverseExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onReverseExpression1(stack["ex"])
}

func (c *current) onRightExpression1(ex, length any) (any, error) {
	return createFunctionCall(parsers.FunctionCallRight, []interface{}{ex, length})
}

func (p *parser) callonRightExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onRightExpression1(stack["ex"], stack["length"])
}

func (c *current) onRTrimExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallRTrim, []interface{}{ex})
}

func (p *parser) callonRTrimExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onRTrimExpression1(stack["ex"])
}

func (c *current) onSubstringExpression1(ex, startPos, length any) (any, error) {
	return createFunctionCall(parsers.FunctionCallSubstring, []interface{}{ex, startPos, length})
}

func (p *parser) callonSubstringExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSubstringExpression1(stack["ex"], stack["startPos"], stack["length"])
}

func (c *current) onTrimExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallTrim, []interface{}{ex})
}

func (p *parser) callonTrimExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onTrimExpression1(stack["ex"])
}

func (c *current) onThreeArgumentStringFunctionExpression18(boolean any) (any, error) {
	return boolean, nil
}

func (p *parser) callonThreeArgumentStringFunctionExpression18() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onThreeArgumentStringFunctionExpression18(stack["boolean"])
}

func (c *current) onThreeArgumentStringFunctionExpression1(function, ex1, ex2, ignoreCase any) (any, error) {
	var functionType parsers.FunctionCallType

	lowerFunction := strings.ToUpper(function.(string))
	switch lowerFunction {
	case "CONTAINS":
		functionType = parsers.FunctionCallContains
	case "ENDSWITH":
		functionType = parsers.FunctionCallEndsWith
	case "STARTSWITH":
		functionType = parsers.FunctionCallStartsWith
	case "INDEX_OF":
		functionType = parsers.FunctionCallIndexOf
	}

	return parsers.FunctionCall{Type: functionType, Arguments: []interface{}{ex1, ex2, ignoreCase}}, nil
}

func (p *parser) callonThreeArgumentStringFunctionExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onThreeArgumentStringFunctionExpression1(stack["function"], stack["ex1"], stack["ex2"], stack["ignoreCase"])
}

func (c *current) onThreeArgumentStringFunction1() (any, error) {
	return string(c.text), nil
}

func (p *parser) callonThreeArgumentStringFunction1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onThreeArgumentStringFunction1()
}

func (c *current) onIsDefined1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsDefined, []interface{}{ex})
}

func (p *parser) callonIsDefined1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsDefined1(stack["ex"])
}

func (c *current) onIsArray1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsArray, []interface{}{ex})
}

func (p *parser) callonIsArray1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsArray1(stack["ex"])
}

func (c *current) onIsBool1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsBool, []interface{}{ex})
}

func (p *parser) callonIsBool1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsBool1(stack["ex"])
}

func (c *current) onIsFiniteNumber1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsFiniteNumber, []interface{}{ex})
}

func (p *parser) callonIsFiniteNumber1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsFiniteNumber1(stack["ex"])
}

func (c *current) onIsInteger1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsInteger, []interface{}{ex})
}

func (p *parser) callonIsInteger1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsInteger1(stack["ex"])
}

func (c *current) onIsNull1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsNull, []interface{}{ex})
}

func (p *parser) callonIsNull1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsNull1(stack["ex"])
}

func (c *current) onIsNumber1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsNumber, []interface{}{ex})
}

func (p *parser) callonIsNumber1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsNumber1(stack["ex"])
}

func (c *current) onIsObject1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsObject, []interface{}{ex})
}

func (p *parser) callonIsObject1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsObject1(stack["ex"])
}

func (c *current) onIsPrimitive1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsPrimitive, []interface{}{ex})
}

func (p *parser) callonIsPrimitive1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsPrimitive1(stack["ex"])
}

func (c *current) onIsString1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsString, []interface{}{ex})
}

func (p *parser) callonIsString1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsString1(stack["ex"])
}

func (c *current) onArrayConcatExpression11(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonArrayConcatExpression11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayConcatExpression11(stack["ex"])
}

func (c *current) onArrayConcatExpression1(arrays, others any) (any, error) {
	return createFunctionCall(parsers.FunctionCallArrayConcat, append([]interface{}{arrays}, others.([]interface{})...))
}

func (p *parser) callonArrayConcatExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayConcatExpression1(stack["arrays"], stack["others"])
}

func (c *current) onArrayLengthExpression1(array any) (any, error) {
	return createFunctionCall(parsers.FunctionCallArrayLength, []interface{}{array})
}

func (p *parser) callonArrayLengthExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayLengthExpression1(stack["array"])
}

func (c *current) onArraySliceExpression16(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonArraySliceExpression16() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArraySliceExpression16(stack["ex"])
}

func (c *current) onArraySliceExpression1(array, start, length any) (any, error) {
	return createFunctionCall(parsers.FunctionCallArraySlice, []interface{}{array, start, length})
}

func (p *parser) callonArraySliceExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArraySliceExpression1(stack["array"], stack["start"], stack["length"])
}

func (c *current) onSetIntersectExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallSetIntersect, []interface{}{set1, set2})
}

func (p *parser) callonSetIntersectExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSetIntersectExpression1(stack["set1"], stack["set2"])
}

func (c *current) onSetUnionExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallSetUnion, []interface{}{set1, set2})
}

func (p *parser) callonSetUnionExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSetUnionExpression1(stack["set1"], stack["set2"])
}

func (c *current) onInFunction14(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonInFunction14() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInFunction14(stack["ex"])
}

func (c *current) onInFunction1(ex1, ex2, others any) (any, error) {
	arguments := append([]interface{}{ex1, ex2}, others.([]interface{})...)
	return parsers.FunctionCall{Type: parsers.FunctionCallIn, Arguments: arguments}, nil
}

func (p *parser) callonInFunction1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInFunction1(stack["ex1"], stack["ex2"], stack["others"])
}

func (c *current) onInteger1() (any, error) {
	return strconv.Atoi(string(c.text))
}

func (p *parser) callonInteger1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInteger1()
}

func (c *current) onStringCharacter2() (any, error) {
	return string(c.text), nil
}

func (p *parser) callonStringCharacter2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringCharacter2()
}

func (c *current) onStringCharacter9(seq any) (any, error) {
	return seq, nil
}

func (p *parser) callonStringCharacter9() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringCharacter9(stack["seq"])
}

func (c *current) onEscapeCharacter5() (any, error) {
	return "\b", nil
}

func (p *parser) callonEscapeCharacter5() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter5()
}

func (c *current) onEscapeCharacter7() (any, error) {
	return "\f", nil
}

func (p *parser) callonEscapeCharacter7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter7()
}

func (c *current) onEscapeCharacter9() (any, error) {
	return "\n", nil
}

func (p *parser) callonEscapeCharacter9() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter9()
}

func (c *current) onEscapeCharacter11() (any, error) {
	return "\r", nil
}

func (p *parser) callonEscapeCharacter11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter11()
}

func (c *current) onEscapeCharacter13() (any, error) {
	return "\t", nil
}

func (p *parser) callonEscapeCharacter13() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter13()
}

func (c *current) onnon_escape_character1(char any) (any, error) {
	return string(c.text), nil
}

func (p *parser) callonnon_escape_character1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onnon_escape_character1(stack["char"])
}

var (
	// errNoRule is returned when the grammar to parse has no rule.
	errNoRule = errors.New("grammar has no rule")

	// errInvalidEntrypoint is returned when the specified entrypoint rule
	// does not exit.
	errInvalidEntrypoint = errors.New("invalid entrypoint")

	// errInvalidEncoding is returned when the source is not properly
	// utf8-encoded.
	errInvalidEncoding = errors.New("invalid encoding")

	// errMaxExprCnt is used to signal that the maximum number of
	// expressions have been parsed.
	errMaxExprCnt = errors.New("max number of expressions parsed")
)

// Option is a function that can set an option on the parser. It returns
// the previous setting as an Option.
type Option func(*parser) Option

// MaxExpressions creates an Option to stop parsing after the provided
// number of expressions have been parsed, if the value is 0 then the parser will
// parse for as many steps as needed (possibly an infinite number).
//
// The default for maxExprCnt is 0.
func MaxExpressions(maxExprCnt uint64) Option {
	return func(p *parser) Option {
		oldMaxExprCnt := p.maxExprCnt
		p.maxExprCnt = maxExprCnt
		return MaxExpressions(oldMaxExprCnt)
	}
}

// Entrypoint creates an Option to set the rule name to use as entrypoint.
// The rule name must have been specified in the -alternate-entrypoints
// if generating the parser with the -optimize-grammar flag, otherwise
// it may have been optimized out. Passing an empty string sets the
// entrypoint to the first rule in the grammar.
//
// The default is to start parsing at the first rule in the grammar.
func Entrypoint(ruleName string) Option {
	return func(p *parser) Option {
		oldEntrypoint := p.entrypoint
		p.entrypoint = ruleName
		if ruleName == "" {
			p.entrypoint = g.rules[0].name
		}
		return Entrypoint(oldEntrypoint)
	}
}

// Statistics adds a user provided Stats struct to the parser to allow
// the user to process the results after the parsing has finished.
// Also the key for the "no match" counter is set.
//
// Example usage:
//
//	input := "input"
//	stats := Stats{}
//	_, err := Parse("input-file", []byte(input), Statistics(&stats, "no match"))
//	if err != nil {
//	    log.Panicln(err)
//	}
//	b, err := json.MarshalIndent(stats.ChoiceAltCnt, "", "  ")
//	if err != nil {
//	    log.Panicln(err)
//	}
//	fmt.Println(string(b))
func Statistics(stats *Stats, choiceNoMatch string) Option {
	return func(p *parser) Option {
		oldStats := p.Stats
		p.Stats = stats
		oldChoiceNoMatch := p.choiceNoMatch
		p.choiceNoMatch = choiceNoMatch
		if p.Stats.ChoiceAltCnt == nil {
			p.Stats.ChoiceAltCnt = make(map[string]map[string]int)
		}
		return Statistics(oldStats, oldChoiceNoMatch)
	}
}

// Debug creates an Option to set the debug flag to b. When set to true,
// debugging information is printed to stdout while parsing.
//
// The default is false.
func Debug(b bool) Option {
	return func(p *parser) Option {
		old := p.debug
		p.debug = b
		return Debug(old)
	}
}

// Memoize creates an Option to set the memoize flag to b. When set to true,
// the parser will cache all results so each expression is evaluated only
// once. This guarantees linear parsing time even for pathological cases,
// at the expense of more memory and slower times for typical cases.
//
// The default is false.
func Memoize(b bool) Option {
	return func(p *parser) Option {
		old := p.memoize
		p.memoize = b
		return Memoize(old)
	}
}

// AllowInvalidUTF8 creates an Option to allow invalid UTF-8 bytes.
// Every invalid UTF-8 byte is treated as a utf8.RuneError (U+FFFD)
// by character class matchers and is matched by the any matcher.
// The returned matched value, c.text and c.offset are NOT affected.
//
// The default is false.
func AllowInvalidUTF8(b bool) Option {
	return func(p *parser) Option {
		old := p.allowInvalidUTF8
		p.allowInvalidUTF8 = b
		return AllowInvalidUTF8(old)
	}
}

// Recover creates an Option to set the recover flag to b. When set to
// true, this causes the parser to recover from panics and convert it
// to an error. Setting it to false can be useful while debugging to
// access the full stack trace.
//
// The default is true.
func Recover(b bool) Option {
	return func(p *parser) Option {
		old := p.recover
		p.recover = b
		return Recover(old)
	}
}

// GlobalStore creates an Option to set a key to a certain value in
// the globalStore.
func GlobalStore(key string, value any) Option {
	return func(p *parser) Option {
		old := p.cur.globalStore[key]
		p.cur.globalStore[key] = value
		return GlobalStore(key, old)
	}
}

// InitState creates an Option to set a key to a certain value in
// the global "state" store.
func InitState(key string, value any) Option {
	return func(p *parser) Option {
		old := p.cur.state[key]
		p.cur.state[key] = value
		return InitState(key, old)
	}
}

// ParseFile parses the file identified by filename.
func ParseFile(filename string, opts ...Option) (i any, err error) {
	f, err := os.Open(filename)
	if err != nil {
		return nil, err
	}
	defer func() {
		if closeErr := f.Close(); closeErr != nil {
			err = closeErr
		}
	}()
	return ParseReader(filename, f, opts...)
}

// ParseReader parses the data from r using filename as information in the
// error messages.
func ParseReader(filename string, r io.Reader, opts ...Option) (any, error) {
	b, err := io.ReadAll(r)
	if err != nil {
		return nil, err
	}

	return Parse(filename, b, opts...)
}

// Parse parses the data from b using filename as information in the
// error messages.
func Parse(filename string, b []byte, opts ...Option) (any, error) {
	return newParser(filename, b, opts...).parse(g)
}

// position records a position in the text.
type position struct {
	line, col, offset int
}

func (p position) String() string {
	return strconv.Itoa(p.line) + ":" + strconv.Itoa(p.col) + " [" + strconv.Itoa(p.offset) + "]"
}

// savepoint stores all state required to go back to this point in the
// parser.
type savepoint struct {
	position
	rn rune
	w  int
}

type current struct {
	pos  position // start position of the match
	text []byte   // raw text of the match

	// state is a store for arbitrary key,value pairs that the user wants to be
	// tied to the backtracking of the parser.
	// This is always rolled back if a parsing rule fails.
	state storeDict

	// globalStore is a general store for the user to store arbitrary key-value
	// pairs that they need to manage and that they do not want tied to the
	// backtracking of the parser. This is only modified by the user and never
	// rolled back by the parser. It is always up to the user to keep this in a
	// consistent state.
	globalStore storeDict
}

type storeDict map[string]any

// the AST types...

type grammar struct {
	pos   position
	rules []*rule
}

type rule struct {
	pos         position
	name        string
	displayName string
	expr        any
}

type choiceExpr struct {
	pos          position
	alternatives []any
}

type actionExpr struct {
	pos  position
	expr any
	run  func(*parser) (any, error)
}

type recoveryExpr struct {
	pos          position
	expr         any
	recoverExpr  any
	failureLabel []string
}

type seqExpr struct {
	pos   position
	exprs []any
}

type throwExpr struct {
	pos   position
	label string
}

type labeledExpr struct {
	pos   position
	label string
	expr  any
}

type expr struct {
	pos  position
	expr any
}

type (
	andExpr        expr
	notExpr        expr
	zeroOrOneExpr  expr
	zeroOrMoreExpr expr
	oneOrMoreExpr  expr
)

type ruleRefExpr struct {
	pos  position
	name string
}

type stateCodeExpr struct {
	pos position
	run func(*parser) error
}

type andCodeExpr struct {
	pos position
	run func(*parser) (bool, error)
}

type notCodeExpr struct {
	pos position
	run func(*parser) (bool, error)
}

type litMatcher struct {
	pos        position
	val        string
	ignoreCase bool
	want       string
}

type charClassMatcher struct {
	pos             position
	val             string
	basicLatinChars [128]bool
	chars           []rune
	ranges          []rune
	classes         []*unicode.RangeTable
	ignoreCase      bool
	inverted        bool
}

type anyMatcher position

// errList cumulates the errors found by the parser.
type errList []error

func (e *errList) add(err error) {
	*e = append(*e, err)
}

func (e errList) err() error {
	if len(e) == 0 {
		return nil
	}
	e.dedupe()
	return e
}

func (e *errList) dedupe() {
	var cleaned []error
	set := make(map[string]bool)
	for _, err := range *e {
		if msg := err.Error(); !set[msg] {
			set[msg] = true
			cleaned = append(cleaned, err)
		}
	}
	*e = cleaned
}

func (e errList) Error() string {
	switch len(e) {
	case 0:
		return ""
	case 1:
		return e[0].Error()
	default:
		var buf bytes.Buffer

		for i, err := range e {
			if i > 0 {
				buf.WriteRune('\n')
			}
			buf.WriteString(err.Error())
		}
		return buf.String()
	}
}

// parserError wraps an error with a prefix indicating the rule in which
// the error occurred. The original error is stored in the Inner field.
type parserError struct {
	Inner    error
	pos      position
	prefix   string
	expected []string
}

// Error returns the error message.
func (p *parserError) Error() string {
	return p.prefix + ": " + p.Inner.Error()
}

// newParser creates a parser with the specified input source and options.
func newParser(filename string, b []byte, opts ...Option) *parser {
	stats := Stats{
		ChoiceAltCnt: make(map[string]map[string]int),
	}

	p := &parser{
		filename: filename,
		errs:     new(errList),
		data:     b,
		pt:       savepoint{position: position{line: 1}},
		recover:  true,
		cur: current{
			state:       make(storeDict),
			globalStore: make(storeDict),
		},
		maxFailPos:      position{col: 1, line: 1},
		maxFailExpected: make([]string, 0, 20),
		Stats:           &stats,
		// start rule is rule [0] unless an alternate entrypoint is specified
		entrypoint: g.rules[0].name,
	}
	p.setOptions(opts)

	if p.maxExprCnt == 0 {
		p.maxExprCnt = math.MaxUint64
	}

	return p
}

// setOptions applies the options to the parser.
func (p *parser) setOptions(opts []Option) {
	for _, opt := range opts {
		opt(p)
	}
}

type resultTuple struct {
	v   any
	b   bool
	end savepoint
}

const choiceNoMatch = -1

// Stats stores some statistics, gathered during parsing
type Stats struct {
	// ExprCnt counts the number of expressions processed during parsing
	// This value is compared to the maximum number of expressions allowed
	// (set by the MaxExpressions option).
	ExprCnt uint64

	// ChoiceAltCnt is used to count for each ordered choice expression,
	// which alternative is used how may times.
	// These numbers allow to optimize the order of the ordered choice expression
	// to increase the performance of the parser
	//
	// The outer key of ChoiceAltCnt is composed of the name of the rule as well
	// as the line and the column of the ordered choice.
	// The inner key of ChoiceAltCnt is the number (one-based) of the matching alternative.
	// For each alternative the number of matches are counted. If an ordered choice does not
	// match, a special counter is incremented. The name of this counter is set with
	// the parser option Statistics.
	// For an alternative to be included in ChoiceAltCnt, it has to match at least once.
	ChoiceAltCnt map[string]map[string]int
}

type parser struct {
	filename string
	pt       savepoint
	cur      current

	data []byte
	errs *errList

	depth   int
	recover bool
	debug   bool

	memoize bool
	// memoization table for the packrat algorithm:
	// map[offset in source] map[expression or rule] {value, match}
	memo map[int]map[any]resultTuple

	// rules table, maps the rule identifier to the rule node
	rules map[string]*rule
	// variables stack, map of label to value
	vstack []map[string]any
	// rule stack, allows identification of the current rule in errors
	rstack []*rule

	// parse fail
	maxFailPos            position
	maxFailExpected       []string
	maxFailInvertExpected bool

	// max number of expressions to be parsed
	maxExprCnt uint64
	// entrypoint for the parser
	entrypoint string

	allowInvalidUTF8 bool

	*Stats

	choiceNoMatch string
	// recovery expression stack, keeps track of the currently available recovery expression, these are traversed in reverse
	recoveryStack []map[string]any
}

// push a variable set on the vstack.
func (p *parser) pushV() {
	if cap(p.vstack) == len(p.vstack) {
		// create new empty slot in the stack
		p.vstack = append(p.vstack, nil)
	} else {
		// slice to 1 more
		p.vstack = p.vstack[:len(p.vstack)+1]
	}

	// get the last args set
	m := p.vstack[len(p.vstack)-1]
	if m != nil && len(m) == 0 {
		// empty map, all good
		return
	}

	m = make(map[string]any)
	p.vstack[len(p.vstack)-1] = m
}

// pop a variable set from the vstack.
func (p *parser) popV() {
	// if the map is not empty, clear it
	m := p.vstack[len(p.vstack)-1]
	if len(m) > 0 {
		// GC that map
		p.vstack[len(p.vstack)-1] = nil
	}
	p.vstack = p.vstack[:len(p.vstack)-1]
}

// push a recovery expression with its labels to the recoveryStack
func (p *parser) pushRecovery(labels []string, expr any) {
	if cap(p.recoveryStack) == len(p.recoveryStack) {
		// create new empty slot in the stack
		p.recoveryStack = append(p.recoveryStack, nil)
	} else {
		// slice to 1 more
		p.recoveryStack = p.recoveryStack[:len(p.recoveryStack)+1]
	}

	m := make(map[string]any, len(labels))
	for _, fl := range labels {
		m[fl] = expr
	}
	p.recoveryStack[len(p.recoveryStack)-1] = m
}

// pop a recovery expression from the recoveryStack
func (p *parser) popRecovery() {
	// GC that map
	p.recoveryStack[len(p.recoveryStack)-1] = nil

	p.recoveryStack = p.recoveryStack[:len(p.recoveryStack)-1]
}

func (p *parser) print(prefix, s string) string {
	if !p.debug {
		return s
	}

	fmt.Printf("%s %d:%d:%d: %s [%#U]\n",
		prefix, p.pt.line, p.pt.col, p.pt.offset, s, p.pt.rn)
	return s
}

func (p *parser) printIndent(mark string, s string) string {
	return p.print(strings.Repeat(" ", p.depth)+mark, s)
}

func (p *parser) in(s string) string {
	res := p.printIndent(">", s)
	p.depth++
	return res
}

func (p *parser) out(s string) string {
	p.depth--
	return p.printIndent("<", s)
}

func (p *parser) addErr(err error) {
	p.addErrAt(err, p.pt.position, []string{})
}

func (p *parser) addErrAt(err error, pos position, expected []string) {
	var buf bytes.Buffer
	if p.filename != "" {
		buf.WriteString(p.filename)
	}
	if buf.Len() > 0 {
		buf.WriteString(":")
	}
	buf.WriteString(fmt.Sprintf("%d:%d (%d)", pos.line, pos.col, pos.offset))
	if len(p.rstack) > 0 {
		if buf.Len() > 0 {
			buf.WriteString(": ")
		}
		rule := p.rstack[len(p.rstack)-1]
		if rule.displayName != "" {
			buf.WriteString("rule " + rule.displayName)
		} else {
			buf.WriteString("rule " + rule.name)
		}
	}
	pe := &parserError{Inner: err, pos: pos, prefix: buf.String(), expected: expected}
	p.errs.add(pe)
}

func (p *parser) failAt(fail bool, pos position, want string) {
	// process fail if parsing fails and not inverted or parsing succeeds and invert is set
	if fail == p.maxFailInvertExpected {
		if pos.offset < p.maxFailPos.offset {
			return
		}

		if pos.offset > p.maxFailPos.offset {
			p.maxFailPos = pos
			p.maxFailExpected = p.maxFailExpected[:0]
		}

		if p.maxFailInvertExpected {
			want = "!" + want
		}
		p.maxFailExpected = append(p.maxFailExpected, want)
	}
}

// read advances the parser to the next rune.
func (p *parser) read() {
	p.pt.offset += p.pt.w
	rn, n := utf8.DecodeRune(p.data[p.pt.offset:])
	p.pt.rn = rn
	p.pt.w = n
	p.pt.col++
	if rn == '\n' {
		p.pt.line++
		p.pt.col = 0
	}

	if rn == utf8.RuneError && n == 1 { // see utf8.DecodeRune
		if !p.allowInvalidUTF8 {
			p.addErr(errInvalidEncoding)
		}
	}
}

// restore parser position to the savepoint pt.
func (p *parser) restore(pt savepoint) {
	if p.debug {
		defer p.out(p.in("restore"))
	}
	if pt.offset == p.pt.offset {
		return
	}
	p.pt = pt
}

// Cloner is implemented by any value that has a Clone method, which returns a
// copy of the value. This is mainly used for types which are not passed by
// value (e.g map, slice, chan) or structs that contain such types.
//
// This is used in conjunction with the global state feature to create proper
// copies of the state to allow the parser to properly restore the state in
// the case of backtracking.
type Cloner interface {
	Clone() any
}

var statePool = &sync.Pool{
	New: func() any { return make(storeDict) },
}

func (sd storeDict) Discard() {
	for k := range sd {
		delete(sd, k)
	}
	statePool.Put(sd)
}

// clone and return parser current state.
func (p *parser) cloneState() storeDict {
	if p.debug {
		defer p.out(p.in("cloneState"))
	}

	state := statePool.Get().(storeDict)
	for k, v := range p.cur.state {
		if c, ok := v.(Cloner); ok {
			state[k] = c.Clone()
		} else {
			state[k] = v
		}
	}
	return state
}

// restore parser current state to the state storeDict.
// every restoreState should applied only one time for every cloned state
func (p *parser) restoreState(state storeDict) {
	if p.debug {
		defer p.out(p.in("restoreState"))
	}
	p.cur.state.Discard()
	p.cur.state = state
}

// get the slice of bytes from the savepoint start to the current position.
func (p *parser) sliceFrom(start savepoint) []byte {
	return p.data[start.position.offset:p.pt.position.offset]
}

func (p *parser) getMemoized(node any) (resultTuple, bool) {
	if len(p.memo) == 0 {
		return resultTuple{}, false
	}
	m := p.memo[p.pt.offset]
	if len(m) == 0 {
		return resultTuple{}, false
	}
	res, ok := m[node]
	return res, ok
}

func (p *parser) setMemoized(pt savepoint, node any, tuple resultTuple) {
	if p.memo == nil {
		p.memo = make(map[int]map[any]resultTuple)
	}
	m := p.memo[pt.offset]
	if m == nil {
		m = make(map[any]resultTuple)
		p.memo[pt.offset] = m
	}
	m[node] = tuple
}

func (p *parser) buildRulesTable(g *grammar) {
	p.rules = make(map[string]*rule, len(g.rules))
	for _, r := range g.rules {
		p.rules[r.name] = r
	}
}

func (p *parser) parse(g *grammar) (val any, err error) {
	if len(g.rules) == 0 {
		p.addErr(errNoRule)
		return nil, p.errs.err()
	}

	// TODO : not super critical but this could be generated
	p.buildRulesTable(g)

	if p.recover {
		// panic can be used in action code to stop parsing immediately
		// and return the panic as an error.
		defer func() {
			if e := recover(); e != nil {
				if p.debug {
					defer p.out(p.in("panic handler"))
				}
				val = nil
				switch e := e.(type) {
				case error:
					p.addErr(e)
				default:
					p.addErr(fmt.Errorf("%v", e))
				}
				err = p.errs.err()
			}
		}()
	}

	startRule, ok := p.rules[p.entrypoint]
	if !ok {
		p.addErr(errInvalidEntrypoint)
		return nil, p.errs.err()
	}

	p.read() // advance to first rune
	val, ok = p.parseRuleWrap(startRule)
	if !ok {
		if len(*p.errs) == 0 {
			// If parsing fails, but no errors have been recorded, the expected values
			// for the farthest parser position are returned as error.
			maxFailExpectedMap := make(map[string]struct{}, len(p.maxFailExpected))
			for _, v := range p.maxFailExpected {
				maxFailExpectedMap[v] = struct{}{}
			}
			expected := make([]string, 0, len(maxFailExpectedMap))
			eof := false
			if _, ok := maxFailExpectedMap["!."]; ok {
				delete(maxFailExpectedMap, "!.")
				eof = true
			}
			for k := range maxFailExpectedMap {
				expected = append(expected, k)
			}
			sort.Strings(expected)
			if eof {
				expected = append(expected, "EOF")
			}
			p.addErrAt(errors.New("no match found, expected: "+listJoin(expected, ", ", "or")), p.maxFailPos, expected)
		}

		return nil, p.errs.err()
	}
	return val, p.errs.err()
}

func listJoin(list []string, sep string, lastSep string) string {
	switch len(list) {
	case 0:
		return ""
	case 1:
		return list[0]
	default:
		return strings.Join(list[:len(list)-1], sep) + " " + lastSep + " " + list[len(list)-1]
	}
}

func (p *parser) parseRuleMemoize(rule *rule) (any, bool) {
	res, ok := p.getMemoized(rule)
	if ok {
		p.restore(res.end)
		return res.v, res.b
	}

	startMark := p.pt
	val, ok := p.parseRule(rule)
	p.setMemoized(startMark, rule, resultTuple{val, ok, p.pt})

	return val, ok
}

func (p *parser) parseRuleWrap(rule *rule) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseRule " + rule.name))
	}
	var (
		val       any
		ok        bool
		startMark = p.pt
	)

	if p.memoize {
		val, ok = p.parseRuleMemoize(rule)
	} else {
		val, ok = p.parseRule(rule)
	}

	if ok && p.debug {
		p.printIndent("MATCH", string(p.sliceFrom(startMark)))
	}
	return val, ok
}

func (p *parser) parseRule(rule *rule) (any, bool) {
	p.rstack = append(p.rstack, rule)
	p.pushV()
	val, ok := p.parseExprWrap(rule.expr)
	p.popV()
	p.rstack = p.rstack[:len(p.rstack)-1]
	return val, ok
}

func (p *parser) parseExprWrap(expr any) (any, bool) {
	var pt savepoint

	if p.memoize {
		res, ok := p.getMemoized(expr)
		if ok {
			p.restore(res.end)
			return res.v, res.b
		}
		pt = p.pt
	}

	val, ok := p.parseExpr(expr)

	if p.memoize {
		p.setMemoized(pt, expr, resultTuple{val, ok, p.pt})
	}
	return val, ok
}

func (p *parser) parseExpr(expr any) (any, bool) {
	p.ExprCnt++
	if p.ExprCnt > p.maxExprCnt {
		panic(errMaxExprCnt)
	}

	var val any
	var ok bool
	switch expr := expr.(type) {
	case *actionExpr:
		val, ok = p.parseActionExpr(expr)
	case *andCodeExpr:
		val, ok = p.parseAndCodeExpr(expr)
	case *andExpr:
		val, ok = p.parseAndExpr(expr)
	case *anyMatcher:
		val, ok = p.parseAnyMatcher(expr)
	case *charClassMatcher:
		val, ok = p.parseCharClassMatcher(expr)
	case *choiceExpr:
		val, ok = p.parseChoiceExpr(expr)
	case *labeledExpr:
		val, ok = p.parseLabeledExpr(expr)
	case *litMatcher:
		val, ok = p.parseLitMatcher(expr)
	case *notCodeExpr:
		val, ok = p.parseNotCodeExpr(expr)
	case *notExpr:
		val, ok = p.parseNotExpr(expr)
	case *oneOrMoreExpr:
		val, ok = p.parseOneOrMoreExpr(expr)
	case *recoveryExpr:
		val, ok = p.parseRecoveryExpr(expr)
	case *ruleRefExpr:
		val, ok = p.parseRuleRefExpr(expr)
	case *seqExpr:
		val, ok = p.parseSeqExpr(expr)
	case *stateCodeExpr:
		val, ok = p.parseStateCodeExpr(expr)
	case *throwExpr:
		val, ok = p.parseThrowExpr(expr)
	case *zeroOrMoreExpr:
		val, ok = p.parseZeroOrMoreExpr(expr)
	case *zeroOrOneExpr:
		val, ok = p.parseZeroOrOneExpr(expr)
	default:
		panic(fmt.Sprintf("unknown expression type %T", expr))
	}
	return val, ok
}

func (p *parser) parseActionExpr(act *actionExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseActionExpr"))
	}

	start := p.pt
	val, ok := p.parseExprWrap(act.expr)
	if ok {
		p.cur.pos = start.position
		p.cur.text = p.sliceFrom(start)
		state := p.cloneState()
		actVal, err := act.run(p)
		if err != nil {
			p.addErrAt(err, start.position, []string{})
		}
		p.restoreState(state)

		val = actVal
	}
	if ok && p.debug {
		p.printIndent("MATCH", string(p.sliceFrom(start)))
	}
	return val, ok
}

func (p *parser) parseAndCodeExpr(and *andCodeExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseAndCodeExpr"))
	}

	state := p.cloneState()

	ok, err := and.run(p)
	if err != nil {
		p.addErr(err)
	}
	p.restoreState(state)

	return nil, ok
}

func (p *parser) parseAndExpr(and *andExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseAndExpr"))
	}

	pt := p.pt
	state := p.cloneState()
	p.pushV()
	_, ok := p.parseExprWrap(and.expr)
	p.popV()
	p.restoreState(state)
	p.restore(pt)

	return nil, ok
}

func (p *parser) parseAnyMatcher(any *anyMatcher) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseAnyMatcher"))
	}

	if p.pt.rn == utf8.RuneError && p.pt.w == 0 {
		// EOF - see utf8.DecodeRune
		p.failAt(false, p.pt.position, ".")
		return nil, false
	}
	start := p.pt
	p.read()
	p.failAt(true, start.position, ".")
	return p.sliceFrom(start), true
}

func (p *parser) parseCharClassMatcher(chr *charClassMatcher) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseCharClassMatcher"))
	}

	cur := p.pt.rn
	start := p.pt

	// can't match EOF
	if cur == utf8.RuneError && p.pt.w == 0 { // see utf8.DecodeRune
		p.failAt(false, start.position, chr.val)
		return nil, false
	}

	if chr.ignoreCase {
		cur = unicode.ToLower(cur)
	}

	// try to match in the list of available chars
	for _, rn := range chr.chars {
		if rn == cur {
			if chr.inverted {
				p.failAt(false, start.position, chr.val)
				return nil, false
			}
			p.read()
			p.failAt(true, start.position, chr.val)
			return p.sliceFrom(start), true
		}
	}

	// try to match in the list of ranges
	for i := 0; i < len(chr.ranges); i += 2 {
		if cur >= chr.ranges[i] && cur <= chr.ranges[i+1] {
			if chr.inverted {
				p.failAt(false, start.position, chr.val)
				return nil, false
			}
			p.read()
			p.failAt(true, start.position, chr.val)
			return p.sliceFrom(start), true
		}
	}

	// try to match in the list of Unicode classes
	for _, cl := range chr.classes {
		if unicode.Is(cl, cur) {
			if chr.inverted {
				p.failAt(false, start.position, chr.val)
				return nil, false
			}
			p.read()
			p.failAt(true, start.position, chr.val)
			return p.sliceFrom(start), true
		}
	}

	if chr.inverted {
		p.read()
		p.failAt(true, start.position, chr.val)
		return p.sliceFrom(start), true
	}
	p.failAt(false, start.position, chr.val)
	return nil, false
}

func (p *parser) incChoiceAltCnt(ch *choiceExpr, altI int) {
	choiceIdent := fmt.Sprintf("%s %d:%d", p.rstack[len(p.rstack)-1].name, ch.pos.line, ch.pos.col)
	m := p.ChoiceAltCnt[choiceIdent]
	if m == nil {
		m = make(map[string]int)
		p.ChoiceAltCnt[choiceIdent] = m
	}
	// We increment altI by 1, so the keys do not start at 0
	alt := strconv.Itoa(altI + 1)
	if altI == choiceNoMatch {
		alt = p.choiceNoMatch
	}
	m[alt]++
}

func (p *parser) parseChoiceExpr(ch *choiceExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseChoiceExpr"))
	}

	for altI, alt := range ch.alternatives {
		// dummy assignment to prevent compile error if optimized
		_ = altI

		state := p.cloneState()

		p.pushV()
		val, ok := p.parseExprWrap(alt)
		p.popV()
		if ok {
			p.incChoiceAltCnt(ch, altI)
			return val, ok
		}
		p.restoreState(state)
	}
	p.incChoiceAltCnt(ch, choiceNoMatch)
	return nil, false
}

func (p *parser) parseLabeledExpr(lab *labeledExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseLabeledExpr"))
	}

	p.pushV()
	val, ok := p.parseExprWrap(lab.expr)
	p.popV()
	if ok && lab.label != "" {
		m := p.vstack[len(p.vstack)-1]
		m[lab.label] = val
	}
	return val, ok
}

func (p *parser) parseLitMatcher(lit *litMatcher) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseLitMatcher"))
	}

	start := p.pt
	for _, want := range lit.val {
		cur := p.pt.rn
		if lit.ignoreCase {
			cur = unicode.ToLower(cur)
		}
		if cur != want {
			p.failAt(false, start.position, lit.want)
			p.restore(start)
			return nil, false
		}
		p.read()
	}
	p.failAt(true, start.position, lit.want)
	return p.sliceFrom(start), true
}

func (p *parser) parseNotCodeExpr(not *notCodeExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseNotCodeExpr"))
	}

	state := p.cloneState()

	ok, err := not.run(p)
	if err != nil {
		p.addErr(err)
	}
	p.restoreState(state)

	return nil, !ok
}

func (p *parser) parseNotExpr(not *notExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseNotExpr"))
	}

	pt := p.pt
	state := p.cloneState()
	p.pushV()
	p.maxFailInvertExpected = !p.maxFailInvertExpected
	_, ok := p.parseExprWrap(not.expr)
	p.maxFailInvertExpected = !p.maxFailInvertExpected
	p.popV()
	p.restoreState(state)
	p.restore(pt)

	return nil, !ok
}

func (p *parser) parseOneOrMoreExpr(expr *oneOrMoreExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseOneOrMoreExpr"))
	}

	var vals []any

	for {
		p.pushV()
		val, ok := p.parseExprWrap(expr.expr)
		p.popV()
		if !ok {
			if len(vals) == 0 {
				// did not match once, no match
				return nil, false
			}
			return vals, true
		}
		vals = append(vals, val)
	}
}

func (p *parser) parseRecoveryExpr(recover *recoveryExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseRecoveryExpr (" + strings.Join(recover.failureLabel, ",") + ")"))
	}

	p.pushRecovery(recover.failureLabel, recover.recoverExpr)
	val, ok := p.parseExprWrap(recover.expr)
	p.popRecovery()

	return val, ok
}

func (p *parser) parseRuleRefExpr(ref *ruleRefExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseRuleRefExpr " + ref.name))
	}

	if ref.name == "" {
		panic(fmt.Sprintf("%s: invalid rule: missing name", ref.pos))
	}

	rule := p.rules[ref.name]
	if rule == nil {
		p.addErr(fmt.Errorf("undefined rule: %s", ref.name))
		return nil, false
	}
	return p.parseRuleWrap(rule)
}

func (p *parser) parseSeqExpr(seq *seqExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseSeqExpr"))
	}

	vals := make([]any, 0, len(seq.exprs))

	pt := p.pt
	state := p.cloneState()
	for _, expr := range seq.exprs {
		val, ok := p.parseExprWrap(expr)
		if !ok {
			p.restoreState(state)
			p.restore(pt)
			return nil, false
		}
		vals = append(vals, val)
	}
	return vals, true
}

func (p *parser) parseStateCodeExpr(state *stateCodeExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseStateCodeExpr"))
	}

	err := state.run(p)
	if err != nil {
		p.addErr(err)
	}
	return nil, true
}

func (p *parser) parseThrowExpr(expr *throwExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseThrowExpr"))
	}

	for i := len(p.recoveryStack) - 1; i >= 0; i-- {
		if recoverExpr, ok := p.recoveryStack[i][expr.label]; ok {
			if val, ok := p.parseExprWrap(recoverExpr); ok {
				return val, ok
			}
		}
	}

	return nil, false
}

func (p *parser) parseZeroOrMoreExpr(expr *zeroOrMoreExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseZeroOrMoreExpr"))
	}

	var vals []any

	for {
		p.pushV()
		val, ok := p.parseExprWrap(expr.expr)
		p.popV()
		if !ok {
			return vals, true
		}
		vals = append(vals, val)
	}
}

func (p *parser) parseZeroOrOneExpr(expr *zeroOrOneExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseZeroOrOneExpr"))
	}

	p.pushV()
	val, _ := p.parseExprWrap(expr.expr)
	p.popV()
	// whether it matched or not, consider it a match
	return val, true
}
